                    PAGE     44,132
                    TITLE    UN51:         8051 dis-assembler

;*********************************************************

FALSE                        EQU      0
TRUE                         EQU      NOT FALSE

;  the following is for special assembly of code
;  to handle unique special cases of "byte following"
;  subroutine calls, such as those of variable length.
;
;  presently, only one such subroutine is supported,
;  and you must write the appropriate code yourself :-)
;
;  set VARIABLE_BYTE_FOLLOWING to true, and search for
;  the conditional assembly code which references it.

VARIABLE_BYTE_FOLLOWING      EQU      FALSE

                             IF       VARIABLE_BYTE_FOLLOWING
BYTE_FOLLOWING_SUB           EQU      025F6H ;02B9DH
                             ENDIF

INSTRUCTION_COLUMN           EQU      11
PARAMETERS_COLUMN            EQU      20
COMMENT_COLUMN               EQU      52
DB_INSTRUCTION_COLUMN        EQU      25
DB_PARAMETERS_COLUMN         EQU      32

;*********************************************************

DOS_FUNCTION        EQU      021H           ;interupt # 021h

PRINT_CHARACTER     EQU      002H
GET_CHARACTER       EQU      008H
PRINT_STRING        EQU      009H
CHECK_KEYBOARD      EQU      00BH
SET_INTERUPT        EQU      025H
OPEN_FILE           EQU      03DH
READ_FILE           EQU      03FH
TERMINATE           EQU      04CH

;*********************************************************

BELL                EQU      007H
TAB                 EQU      009H
LF                  EQU      00AH
CR                  EQU      00DH
EOF                 EQU      01AH

;*********************************************************

HANDLE_VECTOR       STRUC

NO_DATA             DW       ?
NO_DATA_UNC         DW       ?

AJMP_TYPE           DW       ?
ACALL_TYPE          DW       ?

LJMP_TYPE           DW       ?
LCALL_TYPE          DW       ?

BP_REL_TYPE         DW       ?
BP_REL_UNC_TYPE     DW       ?

DL_DIR_BP_REL_TYPE  DW       ?
CL_DIR_BP_REL_TYPE  DW       ?
DL_IMM_BP_REL_TYPE  DW       ?
CL_BIT_BP_REL_TYPE  DW       ?

BP_BYTE_IMM_TYPE    DW       ?
BP_WORD_IMM_TYPE    DW       ?
BP_DIR_TYPE         DW       ?
CL_DIR_TYPE         DW       ?
BP_BIT_TYPE         DW       ?
CL_BIT_TYPE         DW       ?

CL_DIR_BP_IMM_TYPE  DW       ?
CL_DIR_BP_DIR_TYPE  DW       ?

HANDLE_VECTOR       ENDS
 
;*********************************************************

STACK               SEGMENT  PARA STACK
                    DW       0200H DUP ( ? )
STACK               ENDS

;                   ********************

MAP_SEG             SEGMENT  PAGE

START_OF_MAPS       EQU      $
                    PUBLIC   DR_MAP
DR_MAP              DB       ( 256 / 8 ) DUP ( ? )

                    PUBLIC   RL_MAP
RL_MAP              DB       ( 08000H / 4 ) DUP ( ? )

                    PUBLIC   LJ_MAP
LJ_MAP              DB       ( 08000H / 4 ) DUP ( ? )

                    PUBLIC   AJ_MAP
AJ_MAP              DB       ( 08000H / 4 ) DUP ( ? )

                    PUBLIC   LC_MAP
LC_MAP              DB       ( 08000H / 4 ) DUP ( ? )

                    PUBLIC   AC_MAP
AC_MAP              DB       ( 08000H / 4 ) DUP ( ? )

                    PUBLIC   OR_MAP
OR_MAP              DB       ( 08000H / 4 ) DUP ( ? )

                    PUBLIC   FOLLOWING_LIST
FOLLOWING_LIST      DB       ( 50 * 3 ) DUP ( ? )

END_OF_MAPS         EQU      $

MAP_SEG             ENDS

;                   ********************

OBJ_SEG             SEGMENT  PAGE

                    PUBLIC   OBJ_BUFFER
OBJ_BUFFER          DB       08000H DUP ( ? )
                    DB       08000H DUP ( ? )

OBJ_SEG             ENDS

;                   ********************

CSEG                SEGMENT PAGE
                    ASSUME   CS:CSEG,DS:OBJ_SEG,ES:MAP_SEG

                    ORG      0
;*********************************************************

;                             ;........|.........|.........|.........|.........|.........|.........|.........|
OPENING_TEXT        DB       "; UN51:  A General Purpose 8051 Disassembler", CR, LF
                    DB       ";        Ver. 1.02 written by Scott Jennings 6-21-88", CR, LF
                    DB       ";", CR, LF
                    DB       "; USAGE:  UN51 <{infile} >{outfile}", CR, LF
                    DB       ";", CR, LF
                    DB       ";      Input is from standard-in, Output is to standard-out.  The input file", CR, LF
                    DB       '; is in standard INTEL-HEX.  A "fudge" factor, to be added to or subtracted', CR, LF
                    DB       "; from the address field of subsequent INTEL-HEX lines, may be specified", CR, LF
                    DB       "; between lines as either a '+' or a '-' followed by a four digit", CR, LF
                    DB       "; hexadecimal number.", CR, LF
                    DB       ";", CR, LF
                    DB       ';      After the final INTEL-HEX end-of-data record, addresses of "orphan"', CR, LF
                    DB       '; code may be specified as a ',"'>' followed by a four digit hexadecimal", CR, LF
                    DB       "; number; and subroutines which expect a fixed length block of data following", CR, LF
                    DB       "; the CALL may be specified as a '#' followed by the four digit hexadecimal", CR, LF
                    DB       "; address of the routine, followed by a '+', followed by a two digit", CR, LF
                    DB       "; hexadecimal count of the number of bytes of data following the CALL.", CR, LF
                    DB       ";", CR, LF
                    DB       ";             Scott Jennings                Compuserve: 70233,573", CR, LF
                    DB       ";             PO Box 107                         GEnie: SMJ", CR, LF
                    DB       ";             Penn Valley, CA     95946        Prodigy: KRDX48A", CR, LF
                    DB       ";", CR, LF
                    DB       ";====================================================================", CR, LF
                    DB       0

;                   ********************

                    PUBLIC   COLUMN, FUDGE_FACTOR
COLUMN              DW       0
FUDGE_FACTOR        DW       0

                    PUBLIC   HIGHEST_ADDRESS, LOWEST_ADDRESS
HIGHEST_ADDRESS     DW       0
LOWEST_ADDRESS      DW       0

                    PUBLIC   PREVIOUS_ADDRESS
PREVIOUS_ADDRESS    DW       0

                    PUBLIC   BLANK_LINE_FLAG, MAPS_CHANGED_FLAG
BLANK_LINE_FLAG     DB       FALSE
MAPS_CHANGED_FLAG   DB       FALSE

BAD_CHECKSUM        DB       CR, LF, LF, "Bad Checksum in .HEX file"
                    DB       0
NOT_HEX             DB       CR, LF, LF, "Non-Hexadecimal Character in .HEX file"
                    DB       0
UNDEFINED_RECORD    DB       CR, LF, LF, "Unknown Intel-Hex record type"
                    DB       0
PREMATURE_EOF       DB       CR, LF, LF, "No End-Of-File Record found"
                    DB       0
FILE_NAME           DB       "A:ABC\12345678.ABC\12345678.ABC\FILENAM.HEX"
                    DB       0

;                   ********************

ORG_STR             DB       "ORG", 0
EQU_STR             DB       "EQU", 0
END_STR             DB       "END", 0

DOLLAR_MINUS_STR    DB       "$ - ", 0

SHORT_BAR           DB       "********************", CR, LF, 0

LONG_BAR            DB       ";*************************************************"
NEWLINE             DB       CR, LF
NUL_STR             DB       0

SERIAL_LAB          DB       "SERIAL:", 0
RESET_LAB           DB       "RESET:", 0
EXT_INT_0__LAB      DB       "EXTINT0:", 0
TIMER_0_LAB         DB       "TIMER0:", 0
EXT_INT_1_LAB       DB       "EXTINT1:", 0
TIMER_1_LAB         DB       "TIMER1:", 0

OR_LAB              DB       "OR", 0
AJ_LAB              DB       "JP", 0
AC_LAB              DB       "CL", 0
LJ_LAB              DB       "LJ", 0
LC_LAB              DB       "LC", 0
RL_LAB              DB       "RL", 0
DR_LAB              DB       "DR", 0

AB_STR              DB       "AB", 0
_NOT_STR            DB       ", /", 0

A_STR               DB       "A", 0
R0_STR              DB       "R0", 0
R1_STR              DB       "R1", 0
R2_STR              DB       "R2", 0
R3_STR              DB       "R3", 0
R4_STR              DB       "R4", 0
R5_STR              DB       "R5", 0
R6_STR              DB       "R6", 0
R7_STR              DB       "R7", 0
DPTR_STR            DB       "DPTR", 0
PC_STR              DB       "PC", 0
C_STR               DB       "C", 0

_STR                DB       ", ", 0
_IMM_STR            DB       ", #", 0

AT_A_PLUS_STR       DB       "@A + ", 0

_A_STR              DB       ", A", 0

_C_STR              DB       ", C", 0

A__STR              DB       "A, ", 0

AT_R0_STR           DB       "@R0", 0
AT_R1_STR           DB       "@R1", 0
AT_DPTR_STR         DB       "@DPTR", 0

A_AT_R0_STR         DB       "A, @R0", 0
A_AT_R1_STR         DB       "A, @R1", 0
A_AT_DPTR_STR       DB       "A, @DPTR", 0

AT_DPTR_A_STR       DB       "@DPTR, A", 0

A_IMM_STR           DB       "A, #", 0
R0_IMM_STR          DB       "R0, #", 0
R1_IMM_STR          DB       "R1, #", 0
R2_IMM_STR          DB       "R2, #", 0
R3_IMM_STR          DB       "R3, #", 0
R4_IMM_STR          DB       "R4, #", 0
R5_IMM_STR          DB       "R5, #", 0
R6_IMM_STR          DB       "R6, #", 0
R7_IMM_STR          DB       "R7, #", 0

AT_R0_IMM_STR       DB       "@R0, #", 0
AT_R1_IMM_STR       DB       "@R1, #", 0

AT_DPTR_IMM_STR     DB       "@DPTR, #", 0

DB_STR              DB       "DB", 0
DW_STR              DB       "DW", 0
ACALL_STR           DB       "ACALL", 0
ADD_STR             DB       "ADD", 0
ADDC_STR            DB       "ADDC", 0
AJMP_STR            DB       "AJMP", 0
ANL_STR             DB       "ANL", 0
CJNE_STR            DB       "CJNE", 0
CLR_STR             DB       "CLR", 0
CPL_STR             DB       "CPL", 0
DA_STR              DB       "DA", 0
DEC_STR             DB       "DEC", 0
DIV_STR             DB       "DIV", 0
DJNZ_STR            DB       "DJNZ", 0
INC_STR             DB       "INC", 0
JB_STR              DB       "JB", 0
JBC_STR             DB       "JBC", 0
JC_STR              DB       "JC", 0
JMP_STR             DB       "JMP", 0
JNB_STR             DB       "JNB", 0
JNC_STR             DB       "JNC", 0
JNZ_STR             DB       "JNZ", 0
JZ_STR              DB       "JZ", 0
LCALL_STR           DB       "LCALL", 0
LJMP_STR            DB       "LJMP", 0
MOV_STR             DB       "MOV", 0
MOVC_STR            DB       "MOVC", 0
MOVX_STR            DB       "MOVX", 0
MUL_STR             DB       "MUL", 0
NOOP_STR            DB       "NOP", 0
ORL_STR             DB       "ORL", 0
POP_STR             DB       "POP", 0
PUSH_STR            DB       "PUSH", 0
RET_STR             DB       "RET", 0
RETI_STR            DB       "RETI", 0
RL_STR              DB       "RL", 0
RLC_STR             DB       "RLC", 0
RR_STR              DB       "RR", 0
RRC_STR             DB       "RRC", 0
SETB_STR            DB       "SETB", 0
SJMP_STR            DB       "SJMP", 0
SUBB_STR            DB       "SUBB", 0
SWAP_STR            DB       "SWAP", 0
XCH_STR             DB       "XCH", 0
XCHD_STR            DB       "XCHD", 0
XRL_STR             DB       "XRL", 0

;                   ********************

B_STR               DB       "B", 0
ACC_STR             DB       "ACC", 0
TCON_STR            DB       "TCON", 0
TMOD_STR            DB       "TMOD", 0
TL0_STR             DB       "TL0", 0
TL1_STR             DB       "TL1", 0
TH0_STR             DB       "TH0", 0
TH1_STR             DB       "TH1", 0
P1_STR              DB       "P1", 0
SCON_STR            DB       "SCON", 0
SBUF_STR            DB       "SBUF", 0
P2_STR              DB       "P2", 0
IEC_STR             DB       "IEC", 0
P3_STR              DB       "P3", 0
IPC_STR             DB       "IPC", 0
PO_STR              DB       "P0", 0
SP_STR              DB       "SP", 0
DPL_STR             DB       "DPL", 0
DPH_STR             DB       "DPH", 0
PSW_STR             DB       "PSW", 0

;                   PSW
CY_STR              DB       "CY", 0
AC_STR              DB       "AC", 0
F0_STR              DB       "F0", 0
RS0_STR             DB       "RS0", 0
RS1_STR             DB       "RS1", 0
OV_STR              DB       "OV", 0
P_STR               DB       "P", 0

;                   IEC
EA_STR              DB       "EA", 0
ES_STR              DB       "ES", 0
ET1_STR             DB       "ET1", 0
EX1_STR             DB       "EX1", 0
ET0_STR             DB       "ET0", 0
EX0_STR             DB       "EX0", 0

;                   IPC
PS_STR              DB       "PS", 0
PT1_STR             DB       "PT1", 0
PX1_STR             DB       "PX1", 0
PT0_STR             DB       "PT0", 0
PX0_STR             DB       "PX0", 0

;                   TCON
TF1_STR             DB       "TF1", 0
TR1_STR             DB       "TR1", 0
TF0_STR             DB       "TF0", 0
TR0_STR             DB       "TR0", 0
IE1_STR             DB       "IE1", 0
IE0_STR             DB       "IE0", 0
IT1_STR             DB       "IT1", 0
IT0_STR             DB       "IT0", 0

;                   SCON
SM0_STR             DB       "SM0", 0
SM1_STR             DB       "SM1", 0
SM2_STR             DB       "SM2", 0
REN_STR             DB       "REN", 0
TB8_STR             DB       "TB8", 0
RB8_STR             DB       "RB8", 0
TI_STR              DB       "TI", 0
RI_STR              DB       "RI", 0

;                   ********************

RB0_STR             DB       "RB0", 0
RB1_STR             DB       "RB1", 0
RB2_STR             DB       "RB2", 0
RB3_STR             DB       "RB3", 0

;                   ********************

                    PUBLIC   DIS_TABLE
DIS_TABLE           DW       NOOP           ;00
                    DW       AJMP_0         ;01
                    DW       LJMP           ;02
                    DW       RR_A           ;03
                    DW       INC_A          ;04
                    DW       INC_DIR        ;05
                    DW       INC_AT_R0      ;06
                    DW       INC_AT_R1      ;07
                    DW       INC_R0         ;08
                    DW       INC_R1         ;09
                    DW       INC_R2         ;0A
                    DW       INC_R3         ;0B
                    DW       INC_R4         ;0C
                    DW       INC_R5         ;0D
                    DW       INC_R6         ;0E
                    DW       INC_R7         ;0F
                    DW       JBC_BIT_REL    ;10
                    DW       ACALL_0        ;11
                    DW       LCALL          ;12
                    DW       RRC_A          ;13
                    DW       DEC_A          ;14
                    DW       DEC_DIR        ;15
                    DW       DEC_AT_R0      ;16
                    DW       DEC_AT_R1      ;17
                    DW       DEC_R0         ;18
                    DW       DEC_R1         ;19
                    DW       DEC_R2         ;1A
                    DW       DEC_R3         ;1B
                    DW       DEC_R4         ;1C
                    DW       DEC_R5         ;1D
                    DW       DEC_R6         ;1E
                    DW       DEC_R7         ;1F
                    DW       JB_BIT_REL     ;20
                    DW       AJMP_1         ;21
                    DW       RETURN         ;22
                    DW       RL_A           ;23
                    DW       ADDA_IMMEDIATE ;24
                    DW       ADDA_DIR       ;25
                    DW       ADDA_AT_R0     ;26
                    DW       ADDA_AT_R1     ;27
                    DW       ADDA_R0        ;28
                    DW       ADDA_R1        ;29
                    DW       ADDA_R2        ;2A
                    DW       ADDA_R3        ;2B
                    DW       ADDA_R4        ;2C
                    DW       ADDA_R5        ;2D
                    DW       ADDA_R6        ;2E
                    DW       ADDA_R7        ;2F
                    DW       JNB_BIT_REL    ;30
                    DW       ACALL_1        ;31
                    DW       RETURNI        ;32
                    DW       RLC_A          ;33
                    DW       ADDCA_IMM      ;34
                    DW       ADDCA_DIR      ;35
                    DW       ADDCA_AT_R0    ;36
                    DW       ADDCA_AT_R1    ;37
                    DW       ADDCA_R0       ;38
                    DW       ADDCA_R1       ;39
                    DW       ADDCA_R2       ;3A
                    DW       ADDCA_R3       ;3B
                    DW       ADDCA_R4       ;3C
                    DW       ADDCA_R5       ;3D
                    DW       ADDCA_R6       ;3E
                    DW       ADDCA_R7       ;3F
                    DW       JC_REL         ;40
                    DW       AJMP_2         ;41
                    DW       ORL_DIR_A      ;42
                    DW       ORL_DIR_IMM    ;43
                    DW       ORL_A_IMM      ;44
                    DW       ORL_A_DIR      ;45
                    DW       ORL_A_AT_R0    ;46
                    DW       ORL_A_AT_R1    ;47
                    DW       ORL_A_R0       ;48
                    DW       ORL_A_R1       ;49
                    DW       ORL_A_R2       ;4A
                    DW       ORL_A_R3       ;4B
                    DW       ORL_A_R4       ;4C
                    DW       ORL_A_R5       ;4D
                    DW       ORL_A_R6       ;4E
                    DW       ORL_A_R7       ;4F
                    DW       JNC_REL        ;50
                    DW       ACALL_2        ;51
                    DW       ANL_DIR_A      ;52
                    DW       ANL_DIR_IMM    ;53
                    DW       ANL_A_IMM      ;54
                    DW       ANL_A_DIR      ;55
                    DW       ANL_A_AT_R0    ;56
                    DW       ANL_A_AT_R1    ;57
                    DW       ANL_A_R0       ;58
                    DW       ANL_A_R1       ;59
                    DW       ANL_A_R2       ;5A
                    DW       ANL_A_R3       ;5B
                    DW       ANL_A_R4       ;5C
                    DW       ANL_A_R5       ;5D
                    DW       ANL_A_R6       ;5E
                    DW       ANL_A_R7       ;5F
                    DW       JZ_REL         ;60
                    DW       AJMP_3         ;61
                    DW       XRL_DIR_A      ;62
                    DW       XRL_DIR_IMM    ;63
                    DW       XRL_A_IMM      ;64
                    DW       XLR_A_DIR      ;65
                    DW       XLR_A_AT_R0    ;66
                    DW       XLR_A_AT_R1    ;67
                    DW       XRL_A_R0       ;68
                    DW       XRL_A_R1       ;69
                    DW       XRL_A_R2       ;6A
                    DW       XRL_A_R3       ;6B
                    DW       XRL_A_R4       ;6C
                    DW       XRL_A_R5       ;6D
                    DW       XRL_A_R6       ;6E
                    DW       XRL_A_R7       ;6F
                    DW       JNZ_REL        ;70
                    DW       ACALL_3        ;71
                    DW       ORL_C_BIT      ;72
                    DW       JMP_AT_A_DPTR  ;73
                    DW       MOV_A_IMM      ;74
                    DW       MOV_DIR_IMM    ;75
                    DW       MOV_AT_R0_IMM  ;76
                    DW       MOV_AT_R1_IMM  ;77
                    DW       MOV_R0_IMM     ;78
                    DW       MOV_R1_IMM     ;79
                    DW       MOV_R2_IMM     ;7A
                    DW       MOV_R3_IMM     ;7B
                    DW       MOV_R4_IMM     ;7C
                    DW       MOV_R5_IMM     ;7D
                    DW       MOV_R6_IMM     ;7E
                    DW       MOV_R7_IMM     ;7F
                    DW       SJMP_REL       ;80
                    DW       AJMP_4         ;81
                    DW       ANL_C_BIT      ;82
                    DW       MOVC_AATA_PC   ;83
                    DW       DIV_AB         ;84
                    DW       MOV_DIR_DIR    ;85
                    DW       MOV_DIR_AT_R0  ;86
                    DW       MOV_DIR_AT_R1  ;87
                    DW       MOV_DIR_R0     ;88
                    DW       MOV_DIR_R1     ;89
                    DW       MOV_DIR_R2     ;8A
                    DW       MOV_DIR_R3     ;8B
                    DW       MOV_DIR_R4     ;8C
                    DW       MOV_DIR_R5     ;8D
                    DW       MOV_DIR_R6     ;8E
                    DW       MOV_DIR_R7     ;8F
                    DW       MOV_DPTR_IMM   ;90
                    DW       ACALL_4        ;91
                    DW       MOV_BIT_C      ;92
                    DW       MOVC_AATA_DPTR ;93
                    DW       SUBB_A_IMM     ;94
                    DW       SUBB_A_DIR     ;95
                    DW       SUBB_A_AT_R0   ;96
                    DW       SUBB_A_AT_R1   ;97
                    DW       SUBB_A_R0      ;98
                    DW       SUBB_A_R1      ;99
                    DW       SUBB_A_R2      ;9A
                    DW       SUBB_A_R3      ;9B
                    DW       SUBB_A_R4      ;9C
                    DW       SUBB_A_R5      ;9D
                    DW       SUBB_A_R6      ;9E
                    DW       SUBB_A_R7      ;9F
                    DW       ORL_C_NBIT     ;A0
                    DW       AJMP_5         ;A1
                    DW       MOV_C_BIT      ;A2
                    DW       INC_DPTR       ;A3
                    DW       MUL_A          ;A4
                    DW       DB_0A5H        ;A5
                    DW       MOV_AT_R0_DIR  ;A6
                    DW       MOV_AT_R1_DIR  ;A7
                    DW       MOV_R0_DIR     ;A8
                    DW       MOV_R1_DIR     ;A9
                    DW       MOV_R2_DIR     ;AA
                    DW       MOV_R3_DIR     ;AB
                    DW       MOV_R4_DIR     ;AC
                    DW       MOV_R5_DIR     ;AD
                    DW       MOV_R6_DIR     ;AE
                    DW       MOV_R7_DIR     ;AF
                    DW       ANL_C_NBIT     ;B0
                    DW       ACALL_5        ;B1
                    DW       CPL_BIT        ;B2
                    DW       CPL_C          ;B3
                    DW       CJNE_A_IMM_REL ;B4
                    DW       CJNE_A_DIR_REL ;B5
                    DW       CJNE_AT_R0_IMM_REL  ;B6
                    DW       CJNE_AT_R1_IMM_REL  ;B7
                    DW       CJNE_R0_IMM_REL ;B8
                    DW       CJNE_R1_IMM_REL ;B9
                    DW       CJNE_R2_IMM_REL ;BA
                    DW       CJNE_R3_IMM_REL ;BB
                    DW       CJNE_R4_IMM_REL ;BC
                    DW       CJNE_R5_IMM_REL ;BD
                    DW       CJNE_R6_IMM_REL ;BE
                    DW       CJNE_R7_IMM_REL ;BF
                    DW       PUSH_DIR       ;C0
                    DW       AJMP_6         ;C1
                    DW       CLR_BIT        ;C2
                    DW       CLR_C          ;C3
                    DW       SWAP_A         ;C4
                    DW       XCH_A_DIR      ;C5
                    DW       XCH_A_AT_R0    ;C6
                    DW       XCH_A_AT_R1    ;C7
                    DW       XCH_A_R0       ;C8
                    DW       XCH_A_R1       ;C9
                    DW       XCH_A_R2       ;CA
                    DW       XCH_A_R3       ;CB
                    DW       XCH_A_R4       ;CC
                    DW       XCH_A_R5       ;CD
                    DW       XCH_A_R6       ;CE
                    DW       XCH_A_R7       ;CF
                    DW       POP_DIR        ;D0
                    DW       ACALL_6        ;D1
                    DW       SETB_BIT       ;D2
                    DW       SETB_C         ;D3
                    DW       DA_A           ;D4
                    DW       DJNZ_DIR_REL   ;D5
                    DW       XCHD_A_AT_R0   ;D6
                    DW       XCHD_A_AT_R1   ;D7
                    DW       DJNZ_R0_REL    ;D8
                    DW       DJNZ_R1_REL    ;D9
                    DW       DJNZ_R2_REL    ;DA
                    DW       DJNZ_R3_REL    ;DB
                    DW       DJNZ_R4_REL    ;DC
                    DW       DJNZ_R5_REL    ;DD
                    DW       DJNZ_R6_REL    ;DE
                    DW       DJNZ_R7_REL    ;DF
                    DW       MOVX_A_AT_DPTR ;E0
                    DW       AJMP_7         ;E1
                    DW       MOVX_A_AT_R0   ;E2
                    DW       MOVX_A_AT_R1   ;E3
                    DW       CLR_A          ;E4
                    DW       MOV_A_DIR      ;E5
                    DW       MOV_A_AT_R0    ;E6
                    DW       MOV_A_AT_R1    ;E7
                    DW       MOV_A_R0       ;E8
                    DW       MOV_A_R1       ;E9
                    DW       MOV_A_R2       ;EA
                    DW       MOV_A_R3       ;EB
                    DW       MOV_A_R4       ;EC
                    DW       MOV_A_R5       ;ED
                    DW       MOV_A_R6       ;EE
                    DW       MOV_A_R7       ;EF
                    DW       MOVX_AT_DPTR_A ;F0
                    DW       ACALL_7        ;F1
                    DW       MOVX_AT_R0_A   ;F2
                    DW       MOVX_AT_R1_A   ;F3
                    DW       CPL_A          ;F4
                    DW       MOV_DIR_A      ;F5
                    DW       MOV_AT_R0_A    ;F6
                    DW       MOV_AT_R1_A    ;F7
                    DW       MOV_R0_A       ;F8
                    DW       MOV_R1_A       ;F9
                    DW       MOV_R2_A       ;FA
                    DW       MOV_R3_A       ;FB
                    DW       MOV_R4_A       ;FC
                    DW       MOV_R5_A       ;FD
                    DW       MOV_R6_A       ;FE
                    DW       MOV_R7_A       ;FF

;*********************************************************

                    PUBLIC   OUTPUT_TABLE
OUTPUT_TABLE        DW       ONO_DATA
                    DW       ONO_DATA_UNC
                    DW       OAJMP_TYPE
                    DW       OACALL_TYPE
                    DW       OLJMP_TYPE
                    DW       OLCALL_TYPE
                    DW       OBP_REL_TYPE
                    DW       OBP_REL_UNC_TYPE
                    DW       ODL_DIR_BP_REL_TYPE
                    DW       OCL_DIR_BP_REL_TYPE
                    DW       ODL_IMM_BP_REL_TYPE
                    DW       OCL_BIT_BP_REL_TYPE
                    DW       OBP_BYTE_IMM_TYPE
                    DW       OBP_WORD_IMM_TYPE
                    DW       OBP_DIR_TYPE
                    DW       OCL_DIR_TYPE
                    DW       OBP_BIT_TYPE
                    DW       OCL_BIT_TYPE
                    DW       OCL_DIR_BP_IMM_TYPE
                    DW       OCL_DIR_BP_DIR_TYPE

;*********************************************************

                    PUBLIC   INPUT_TABLE
INPUT_TABLE         DW       INO_DATA
                    DW       INO_DATA_UNC
                    DW       IAJMP_TYPE
                    DW       IACALL_TYPE
                    DW       ILJMP_TYPE
                    DW       ILCALL_TYPE
                    DW       IBP_REL_TYPE
                    DW       IBP_REL_UNC_TYPE
                    DW       IDL_DIR_BP_REL_TYPE
                    DW       ICL_DIR_BP_REL_TYPE
                    DW       IDL_IMM_BP_REL_TYPE
                    DW       ICL_BIT_BP_REL_TYPE
                    DW       IBP_BYTE_IMM_TYPE
                    DW       IBP_WORD_IMM_TYPE
                    DW       IBP_DIR_TYPE
                    DW       ICL_DIR_TYPE
                    DW       IBP_BIT_TYPE
                    DW       ICL_BIT_TYPE
                    DW       ICL_DIR_BP_IMM_TYPE
                    DW       ICL_DIR_BP_DIR_TYPE

;*********************************************************

                    PUBLIC   DIR_TABLE
DIR_TABLE           DW       PO_STR         ;80
                    DW       SP_STR         ;81
                    DW       DPL_STR        ;82
                    DW       DPH_STR        ;83
                    DW       0              ;84
                    DW       0              ;85
                    DW       0              ;86
                    DW       0              ;87
                    DW       TCON_STR       ;88 *
                    DW       TMOD_STR       ;89 *
                    DW       TL0_STR        ;8A
                    DW       TL1_STR        ;8B
                    DW       TH0_STR        ;8C
                    DW       TH1_STR        ;8D
                    DW       0              ;8E
                    DW       0              ;8F
                    DW       P1_STR         ;90
                    DW       0              ;91
                    DW       0              ;92
                    DW       0              ;93
                    DW       0              ;94
                    DW       0              ;95
                    DW       0              ;96
                    DW       0              ;97
                    DW       SCON_STR       ;98 *
                    DW       SBUF_STR       ;99
                    DW       0              ;9A
                    DW       0              ;9B
                    DW       0              ;9C
                    DW       0              ;9D
                    DW       0              ;9E
                    DW       0              ;9F
                    DW       P2_STR         ;A0
                    DW       0              ;A1
                    DW       0              ;A2
                    DW       0              ;A3
                    DW       0              ;A4
                    DW       0              ;A5
                    DW       0              ;A6
                    DW       0              ;A7
                    DW       IEC_STR        ;A8 *
                    DW       0              ;A9
                    DW       0              ;AA
                    DW       0              ;AB
                    DW       0              ;AC
                    DW       0              ;AD
                    DW       0              ;AE
                    DW       0              ;AF
                    DW       P3_STR         ;B0 *
                    DW       0              ;B1
                    DW       0              ;B2
                    DW       0              ;B3
                    DW       0              ;B4
                    DW       0              ;B5
                    DW       0              ;B6
                    DW       0              ;B7
                    DW       IPC_STR        ;B8 *
                    DW       0              ;B9
                    DW       0              ;BA
                    DW       0              ;BB
                    DW       0              ;BC
                    DW       0              ;BD
                    DW       0              ;BE
                    DW       0              ;BF
                    DW       0              ;C0
                    DW       0              ;C1
                    DW       0              ;C2
                    DW       0              ;C3
                    DW       0              ;C4
                    DW       0              ;C5
                    DW       0              ;C6
                    DW       0              ;C7
                    DW       0              ;C8
                    DW       0              ;C9
                    DW       0              ;CA
                    DW       0              ;CB
                    DW       0              ;CC
                    DW       0              ;CD
                    DW       0              ;CE
                    DW       0              ;CF
                    DW       PSW_STR        ;D0 *
                    DW       0              ;D1
                    DW       0              ;D2
                    DW       0              ;D3
                    DW       0              ;D4
                    DW       0              ;D5
                    DW       0              ;D6
                    DW       0              ;D7
                    DW       0              ;D8
                    DW       0              ;D9
                    DW       0              ;DA
                    DW       0              ;DB
                    DW       0              ;DC
                    DW       0              ;DD
                    DW       0              ;DE
                    DW       0              ;DF
                    DW       ACC_STR        ;E0
                    DW       0              ;E1
                    DW       0              ;E2
                    DW       0              ;E3
                    DW       0              ;E4
                    DW       0              ;E5
                    DW       0              ;E6
                    DW       0              ;E7
                    DW       0              ;E8
                    DW       0              ;E9
                    DW       0              ;EA
                    DW       0              ;EB
                    DW       0              ;EC
                    DW       0              ;ED
                    DW       0              ;EE
                    DW       0              ;EF
                    DW       B_STR          ;F0
                    DW       0              ;F1
                    DW       0              ;F2
                    DW       0              ;F3
                    DW       0              ;F4
                    DW       0              ;F5
                    DW       0              ;F6
                    DW       0              ;F7
                    DW       0              ;F8
                    DW       0              ;F9
                    DW       0              ;FA
                    DW       0              ;FB
                    DW       0              ;FC
                    DW       0              ;FD
                    DW       0              ;FE
                    DW       0              ;FF

;                   ********************

RB_TABLE            DW       RB0_STR
                    DW       RB1_STR
                    DW       RB2_STR
                    DW       RB3_STR

;                   ********************

REG_TABLE           DW       R0_STR
                    DW       R1_STR
                    DW       R2_STR
                    DW       R3_STR
                    DW       R4_STR
                    DW       R5_STR
                    DW       R6_STR
                    DW       R7_STR

;                   ********************

TCON_TABLE          DW       IT0_STR
                    DW       IE0_STR
                    DW       IT1_STR
                    DW       IE1_STR
                    DW       TR0_STR
                    DW       TF0_STR
                    DW       TR1_STR
                    DW       TF1_STR

TMOD_TABLE          DW       0
                    DW       0
                    DW       0
                    DW       0
                    DW       0
                    DW       0
                    DW       0
                    DW       0

SCON_TABLE          DW       RI_STR
                    DW       TI_STR
                    DW       RB8_STR
                    DW       TB8_STR
                    DW       REN_STR
                    DW       SM2_STR
                    DW       SM1_STR
                    DW       SM0_STR

IEC_TABLE           DW       EX0_STR
                    DW       ET0_STR
                    DW       EX1_STR
                    DW       ET1_STR
                    DW       ES_STR
                    DW       0
                    DW       0
                    DW       EA_STR

P3_TABLE            DW       0 ;RXD_STR
                    DW       0 ;TXD_STR
                    DW       0 ;INT0_STR
                    DW       0 ;INT1_STR
                    DW       0 ;T0_STR
                    DW       0 ;T1_STR
                    DW       0 ;WR_STR
                    DW       0 ;RD_STR

IPC_TABLE           DW       PX0_STR
                    DW       PT0_STR
                    DW       PX1_STR
                    DW       PT1_STR
                    DW       PS_STR
                    DW       0
                    DW       0
                    DW       0

PSW_TABLE           DW       P_STR
                    DW       0
                    DW       OV_STR
                    DW       RS0_STR
                    DW       RS1_STR
                    DW       F0_STR
                    DW       AC_STR
                    DW       CY_STR

;*********************************************************

                    PUBLIC   NOOP
;***
NOOP                PROC     NEAR
;***
                    MOV      AX, OFFSET NOOP_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET                     
;                   ********************

NOOP                ENDP

;*********************************************************

                    PUBLIC   AJMP_0
;*****
AJMP_0              PROC     NEAR
;*****
                    MOV      AX, SI
                    AND      AH, 11111000B
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET AJMP_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, AJMP_TYPE
                    RET
;                   ********************

AJMP_0              ENDP

;*********************************************************

                    PUBLIC   LJMP
;***
LJMP                PROC     NEAR
;***
                    LODSW
                    XCHG     AH, AL
                    MOV      BP, AX
                    MOV      AX, OFFSET LJMP_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, LJMP_TYPE
                    RET
;                   ********************

LJMP                ENDP

;*********************************************************

                    PUBLIC   RR_A
;***
RR_A                PROC     NEAR
;***
                    MOV      AX, OFFSET RR_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

RR_A                ENDP

;*********************************************************

;****
INC_A               PROC     NEAR
;****
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_A               ENDP

;*********************************************************

;******
INC_DIR             PROC     NEAR
;******
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

INC_DIR             ENDP

;*********************************************************

;********
INC_AT_R0           PROC     NEAR
;********
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_AT_R0           ENDP

;*********************************************************

;********
INC_AT_R1           PROC     NEAR
;********
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_AT_R1           ENDP

;*********************************************************

;*****
INC_R0              PROC     NEAR
;*****
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_R0              ENDP

;*********************************************************

;*****
INC_R1              PROC     NEAR
;*****
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_R1              ENDP

;*********************************************************

;*****
INC_R2              PROC     NEAR
;*****
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET R2_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_R2              ENDP

;*********************************************************

;*****
INC_R3              PROC     NEAR
;*****
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET R3_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_R3              ENDP

;*********************************************************

;*****
INC_R4              PROC     NEAR
;*****
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET R4_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_R4              ENDP

;*********************************************************

;*****
INC_R5              PROC     NEAR
;*****
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET R5_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_R5              ENDP

;*********************************************************

;*****
INC_R6              PROC     NEAR
;*****
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET R6_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_R6              ENDP

;*********************************************************

;*****
INC_R7              PROC     NEAR
;*****
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET R7_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_R7              ENDP

;*********************************************************

;**********
JBC_BIT_REL         PROC     NEAR
;**********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET JBC_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, CL_BIT_BP_REL_TYPE
                    RET
;                   ********************

JBC_BIT_REL         ENDP

;*********************************************************

;******
ACALL_0             PROC     NEAR
;******
                    MOV      AX, SI
                    AND      AH, 11111000B
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ACALL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, ACALL_TYPE
                    RET
;                   ********************

ACALL_0             ENDP

;*********************************************************

;****
LCALL               PROC     NEAR
;****
                    LODSW
                    XCHG     AH, AL
                    MOV      BP, AX
                    MOV      AX, OFFSET LCALL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, LCALL_TYPE
                    RET
;                   ********************

LCALL               ENDP

;*********************************************************

;****
RRC_A               PROC     NEAR
;****
                    MOV      AX, OFFSET RRC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

RRC_A               ENDP

;*********************************************************

;****
DEC_A               PROC     NEAR
;****
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_A               ENDP

;*********************************************************

;******
DEC_DIR             PROC     NEAR
;******
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

DEC_DIR             ENDP

;*********************************************************

;********
DEC_AT_R0           PROC     NEAR
;********
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_AT_R0           ENDP

;*********************************************************

;********
DEC_AT_R1           PROC     NEAR
;********
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_AT_R1           ENDP

;*********************************************************

;*****
DEC_R0              PROC     NEAR
;*****
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_R0              ENDP

;*********************************************************

;*****
DEC_R1              PROC     NEAR
;*****
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_R1              ENDP

;*********************************************************

;*****
DEC_R2              PROC     NEAR
;*****
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET R2_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_R2              ENDP

;*********************************************************

;*****
DEC_R3              PROC     NEAR
;*****
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET R3_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_R3              ENDP

;*********************************************************

;*****
DEC_R4              PROC     NEAR
;*****
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET R4_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_R4              ENDP

;*********************************************************

;*****
DEC_R5              PROC     NEAR
;*****
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET R5_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_R5              ENDP

;*********************************************************

;*****
DEC_R6              PROC     NEAR
;*****
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET R6_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_R6              ENDP

;*********************************************************

;*****
DEC_R7              PROC     NEAR
;*****
                    MOV      AX, OFFSET DEC_STR
                    MOV      CX, OFFSET R7_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DEC_R7              ENDP

;*********************************************************

;*********
JB_BIT_REL          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET JB_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, CL_BIT_BP_REL_TYPE
                    RET
;                   ********************

JB_BIT_REL          ENDP

;*********************************************************

;*****
AJMP_1              PROC     NEAR
;*****
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 1
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET AJMP_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, AJMP_TYPE
                    RET
;                   ********************

AJMP_1              ENDP

;*********************************************************

;*****
RETURN              PROC     NEAR
;*****
                    MOV      AX, OFFSET RET_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA_UNC
                    RET
;                   ********************

RETURN              ENDP

;*********************************************************

;***
RL_A                PROC     NEAR
;***
                    MOV      AX, OFFSET RL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

RL_A                ENDP

;*********************************************************

;*************
ADDA_IMMEDIATE      PROC     NEAR
;*************
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE                    
                    RET
;                   ********************

ADDA_IMMEDIATE      ENDP

;*********************************************************

;*******
ADDA_DIR            PROC     NEAR
;*******
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

ADDA_DIR            ENDP

;*********************************************************

;*********
ADDA_AT_R0          PROC     NEAR
;*********
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_AT_R0          ENDP

;*********************************************************

;*********
ADDA_AT_R1          PROC     NEAR
;*********
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_AT_R1          ENDP

;*********************************************************

;******
ADDA_R0             PROC     NEAR
;******
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R0_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_R0             ENDP

;*********************************************************

;******
ADDA_R1             PROC     NEAR
;******
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R1_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_R1             ENDP

;*********************************************************

;******
ADDA_R2             PROC     NEAR
;******
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R2_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_R2             ENDP

;*********************************************************

;******
ADDA_R3             PROC     NEAR
;******
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R3_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_R3             ENDP

;*********************************************************

;******
ADDA_R4             PROC     NEAR
;******
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R4_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_R4             ENDP

;*********************************************************

;******
ADDA_R5             PROC     NEAR
;******
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R5_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_R5             ENDP

;*********************************************************

;******
ADDA_R6             PROC     NEAR
;******
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R6_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_R6             ENDP

;*********************************************************

;******
ADDA_R7             PROC     NEAR
;******
                    MOV      AX, OFFSET ADD_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R7_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDA_R7             ENDP

;*********************************************************

;**********
JNB_BIT_REL         PROC     NEAR
;**********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET JNB_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, CL_BIT_BP_REL_TYPE
                    RET
;                   ********************

JNB_BIT_REL         ENDP

;*********************************************************

;******
ACALL_1             PROC     NEAR
;******
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 1
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ACALL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, ACALL_TYPE
                    RET
;                   ********************

ACALL_1             ENDP

;*********************************************************

;******
RETURNI             PROC     NEAR
;******
                    MOV      AX, OFFSET RETI_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA_UNC
                    RET
;                   ********************

RETURNI             ENDP

;*********************************************************

;****
RLC_A               PROC     NEAR
;****
                    MOV      AX, OFFSET RLC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

RLC_A               ENDP

;*********************************************************

;********
ADDCA_IMM           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

ADDCA_IMM           ENDP

;*********************************************************

;********
ADDCA_DIR           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

ADDCA_DIR           ENDP

;*********************************************************

;**********
ADDCA_AT_R0         PROC     NEAR
;**********
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_AT_R0         ENDP

;*********************************************************

;**********
ADDCA_AT_R1         PROC     NEAR
;**********
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_AT_R1         ENDP

;*********************************************************

;*******
ADDCA_R0            PROC     NEAR
;*******
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R0_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_R0            ENDP

;*********************************************************

;*******
ADDCA_R1            PROC     NEAR
;*******
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R1_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_R1            ENDP

;*********************************************************

;*******
ADDCA_R2            PROC     NEAR
;*******
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R2_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_R2            ENDP

;*********************************************************

;*******
ADDCA_R3            PROC     NEAR
;*******
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R3_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_R3            ENDP

;*********************************************************

;*******
ADDCA_R4            PROC     NEAR
;*******
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R4_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_R4            ENDP

;*********************************************************

;*******
ADDCA_R5            PROC     NEAR
;*******
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R5_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_R5            ENDP

;*********************************************************

;*******
ADDCA_R6            PROC     NEAR
;*******
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R6_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_R6            ENDP

;*********************************************************

;*******
ADDCA_R7            PROC     NEAR
;*******
                    MOV      AX, OFFSET ADDC_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R7_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ADDCA_R7            ENDP

;*********************************************************

;*****
JC_REL              PROC     NEAR
;*****
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET JC_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

JC_REL              ENDP

;*********************************************************

;*****
AJMP_2              PROC     NEAR
;*****
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 2
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET AJMP_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, AJMP_TYPE
                    RET
;                   ********************

AJMP_2              ENDP

;*********************************************************

;********
ORL_DIR_A           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET ORL_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

ORL_DIR_A           ENDP

;*********************************************************

;**********
ORL_DIR_IMM         PROC     NEAR
;**********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ORL_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, CL_DIR_BP_IMM_TYPE
                    RET
;                   ********************

ORL_DIR_IMM         ENDP

;*********************************************************

;********
ORL_A_IMM           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

ORL_A_IMM           ENDP

;*********************************************************

;********
ORL_A_DIR           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

ORL_A_DIR           ENDP

;*********************************************************

;**********
ORL_A_AT_R0         PROC     NEAR
;**********
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_AT_R0         ENDP

;*********************************************************

;**********
ORL_A_AT_R1         PROC     NEAR
;**********
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_AT_R1         ENDP

;*********************************************************

;*******
ORL_A_R0            PROC     NEAR
;*******
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R0_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_R0            ENDP

;*********************************************************

;*******
ORL_A_R1            PROC     NEAR
;*******
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R1_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_R1            ENDP

;*********************************************************

;*******
ORL_A_R2            PROC     NEAR
;*******
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R2_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_R2            ENDP

;*********************************************************

;*******
ORL_A_R3            PROC     NEAR
;*******
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R3_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_R3            ENDP

;*********************************************************

;*******
ORL_A_R4            PROC     NEAR
;*******
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R4_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_R4            ENDP

;*********************************************************

;*******
ORL_A_R5            PROC     NEAR
;*******
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R5_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_R5            ENDP

;*********************************************************

;*******
ORL_A_R6            PROC     NEAR
;*******
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R6_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_R6            ENDP

;*********************************************************

;*******
ORL_A_R7            PROC     NEAR
;*******
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R7_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ORL_A_R7            ENDP

;*********************************************************

;******
JNC_REL             PROC     NEAR
;******
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET JNC_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

JNC_REL             ENDP

;*********************************************************

;******
ACALL_2             PROC     NEAR
;******
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 2
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ACALL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, ACALL_TYPE
                    RET
;                   ********************

ACALL_2             ENDP

;*********************************************************

;********
ANL_DIR_A           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET ANL_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

ANL_DIR_A           ENDP

;*********************************************************

;**********
ANL_DIR_IMM         PROC     NEAR
;**********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ANL_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, CL_DIR_BP_IMM_TYPE
                    RET
;                   ********************

ANL_DIR_IMM         ENDP

;*********************************************************

;********
ANL_A_IMM           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_IMM_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

ANL_A_IMM           ENDP

;*********************************************************

;********
ANL_A_DIR           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

ANL_A_DIR           ENDP

;*********************************************************

;**********
ANL_A_AT_R0         PROC     NEAR
;**********
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_AT_R0         ENDP

;*********************************************************

;**********
ANL_A_AT_R1         PROC     NEAR
;**********
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_AT_R1         ENDP

;*********************************************************

;*******
ANL_A_R0            PROC     NEAR
;*******
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R0_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_R0            ENDP

;*********************************************************

;*******
ANL_A_R1            PROC     NEAR
;*******
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R1_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_R1            ENDP

;*********************************************************

;*******
ANL_A_R2            PROC     NEAR
;*******
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R2_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_R2            ENDP

;*********************************************************

;*******
ANL_A_R3            PROC     NEAR
;*******
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R3_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_R3            ENDP

;*********************************************************

;*******
ANL_A_R4            PROC     NEAR
;*******
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R4_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_R4            ENDP

;*********************************************************

;*******
ANL_A_R5            PROC     NEAR
;*******
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R5_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_R5            ENDP

;*********************************************************

;*******
ANL_A_R6            PROC     NEAR
;*******
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R6_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_R6            ENDP

;*********************************************************

;*******
ANL_A_R7            PROC     NEAR
;*******
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R7_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

ANL_A_R7            ENDP

;*********************************************************

;*****
JZ_REL              PROC     NEAR
;*****
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET JZ_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

JZ_REL              ENDP

;*********************************************************

;*****
AJMP_3              PROC     NEAR
;*****
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 3
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET AJMP_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, AJMP_TYPE
                    RET
;                   ********************

AJMP_3              ENDP

;*********************************************************

;********
XRL_DIR_A           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET XRL_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

XRL_DIR_A           ENDP

;*********************************************************

;**********
XRL_DIR_IMM         PROC     NEAR
;**********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET XRL_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, CL_DIR_BP_IMM_TYPE
                    RET
;                   ********************

XRL_DIR_IMM         ENDP

;*********************************************************

;********
XRL_A_IMM           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

XRL_A_IMM           ENDP

;*********************************************************

;********
XLR_A_DIR           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

XLR_A_DIR           ENDP

;*********************************************************

;**********
XLR_A_AT_R0         PROC     NEAR
;**********
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XLR_A_AT_R0         ENDP

;*********************************************************

;**********
XLR_A_AT_R1         PROC     NEAR
;**********
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XLR_A_AT_R1         ENDP

;*********************************************************

;*******
XRL_A_R0            PROC     NEAR
;*******
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R0_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XRL_A_R0            ENDP

;*********************************************************

;*******
XRL_A_R1            PROC     NEAR
;*******
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R1_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XRL_A_R1            ENDP

;*********************************************************

;*******
XRL_A_R2            PROC     NEAR
;*******
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R2_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XRL_A_R2            ENDP

;*********************************************************

;*******
XRL_A_R3            PROC     NEAR
;*******
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R3_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XRL_A_R3            ENDP

;*********************************************************

;*******
XRL_A_R4            PROC     NEAR
;*******
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R4_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XRL_A_R4            ENDP

;*********************************************************

;*******
XRL_A_R5            PROC     NEAR
;*******
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R5_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XRL_A_R5            ENDP

;*********************************************************

;*******
XRL_A_R6            PROC     NEAR
;*******
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R6_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XRL_A_R6            ENDP

;*********************************************************

;*******
XRL_A_R7            PROC     NEAR
;*******
                    MOV      AX, OFFSET XRL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R7_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XRL_A_R7            ENDP

;*********************************************************

;******
JNZ_REL             PROC     NEAR
;******
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET JNZ_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

JNZ_REL             ENDP

;*********************************************************

;******
ACALL_3             PROC     NEAR
;******
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 3
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ACALL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, ACALL_TYPE
                    RET
;                   ********************

ACALL_3             ENDP

;*********************************************************

;********
ORL_C_BIT           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET C_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_BIT_TYPE
                    RET
;                   ********************

ORL_C_BIT           ENDP

;*********************************************************

;************
JMP_AT_A_DPTR       PROC     NEAR
;************
                    MOV      AX, OFFSET JMP_STR
                    MOV      CX, OFFSET AT_A_PLUS_STR
                    MOV      DX, OFFSET DPTR_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA_UNC
                    RET
;                   ********************

JMP_AT_A_DPTR       ENDP

;*********************************************************

;********
MOV_A_IMM           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_A_IMM           ENDP

;*********************************************************

;**********
MOV_DIR_IMM         PROC     NEAR
;**********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, CL_DIR_BP_IMM_TYPE
                    RET
;                   ********************

MOV_DIR_IMM         ENDP

;*********************************************************

;************
MOV_AT_R0_IMM       PROC     NEAR
;************
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET AT_R0_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_AT_R0_IMM       ENDP

;*********************************************************

;************
MOV_AT_R1_IMM       PROC     NEAR
;************
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET AT_R1_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_AT_R1_IMM       ENDP

;*********************************************************

;*********
MOV_R0_IMM          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R0_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_R0_IMM          ENDP

;*********************************************************

;*********
MOV_R1_IMM          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R1_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_R1_IMM          ENDP

;*********************************************************

;*********
MOV_R2_IMM          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R2_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_R2_IMM          ENDP

;*********************************************************

;*********
MOV_R3_IMM          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R3_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_R3_IMM          ENDP

;*********************************************************

;*********
MOV_R4_IMM          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R4_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_R4_IMM          ENDP

;*********************************************************

;*********
MOV_R5_IMM          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R5_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_R5_IMM          ENDP

;*********************************************************

;*********
MOV_R6_IMM          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R6_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_R6_IMM          ENDP

;*********************************************************

;*********
MOV_R7_IMM          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R7_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

MOV_R7_IMM          ENDP

;*********************************************************

;*******
SJMP_REL            PROC     NEAR
;*******
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET SJMP_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_REL_UNC_TYPE
                    RET
;                   ********************

SJMP_REL            ENDP

;*********************************************************

;*****
AJMP_4              PROC     NEAR
;*****
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 4
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET AJMP_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, AJMP_TYPE
                    RET
;                   ********************

AJMP_4              ENDP

;*********************************************************

;********
ANL_C_BIT           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET C_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_BIT_TYPE
                    RET
;                   ********************

ANL_C_BIT           ENDP

;*********************************************************

;***********
MOVC_AATA_PC        PROC     NEAR
;***********
                    MOV      AX, OFFSET MOVC_STR
                    MOV      CX, OFFSET A__STR
                    MOV      DX, OFFSET AT_A_PLUS_STR
                    MOV      BP, OFFSET PC_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOVC_AATA_PC        ENDP

;*********************************************************

;*****
DIV_AB              PROC     NEAR
;*****
                    MOV      AX, OFFSET DIV_STR
                    MOV      CX, OFFSET AB_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DIV_AB              ENDP

;*********************************************************

;**********
MOV_DIR_DIR         PROC     NEAR
;**********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, CL_DIR_BP_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_DIR         ENDP

;*********************************************************

;************
MOV_DIR_AT_R0       PROC     NEAR
;************
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET AT_R0_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_AT_R0       ENDP

;*********************************************************

;************
MOV_DIR_AT_R1       PROC     NEAR
;************
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET AT_R1_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_AT_R1       ENDP

;*********************************************************

;*********
MOV_DIR_R0          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R0_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_R0          ENDP

;*********************************************************

;*********
MOV_DIR_R1          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R1_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_R1          ENDP

;*********************************************************

;*********
MOV_DIR_R2          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R2_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_R2          ENDP

;*********************************************************

;*********
MOV_DIR_R3          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R3_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_R3          ENDP

;*********************************************************

;*********
MOV_DIR_R4          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R4_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_R4          ENDP

;*********************************************************

;*********
MOV_DIR_R5          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R5_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_R5          ENDP

;*********************************************************

;*********
MOV_DIR_R6          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R6_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_R6          ENDP

;*********************************************************

;*********
MOV_DIR_R7          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R7_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_R7          ENDP

;*********************************************************

;***********
MOV_DPTR_IMM        PROC     NEAR
;***********
                    LODSW
                    XCHG     AL, AH
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET DPTR_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_WORD_IMM_TYPE
                    RET
;                   ********************

MOV_DPTR_IMM        ENDP

;*********************************************************

;******
ACALL_4             PROC     NEAR
;******
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 4
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ACALL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, ACALL_TYPE
                    RET
;                   ********************

ACALL_4             ENDP

;*********************************************************

;********
MOV_BIT_C           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET C_STR
                    MOV      BX, CL_BIT_TYPE
                    RET
;                   ********************

MOV_BIT_C           ENDP

;*********************************************************

;*************
MOVC_AATA_DPTR      PROC     NEAR
;*************
                    MOV      AX, OFFSET MOVC_STR
                    MOV      CX, OFFSET A__STR
                    MOV      DX, OFFSET AT_A_PLUS_STR
                    MOV      BP, OFFSET DPTR_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOVC_AATA_DPTR      ENDP

;*********************************************************

;*********
SUBB_A_IMM          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _IMM_STR
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

SUBB_A_IMM          ENDP

;*********************************************************

;*********
SUBB_A_DIR          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

SUBB_A_DIR          ENDP

;*********************************************************

;***********
SUBB_A_AT_R0        PROC     NEAR
;***********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_AT_R0        ENDP

;*********************************************************

;***********
SUBB_A_AT_R1        PROC     NEAR
;***********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_AT_R1        ENDP

;*********************************************************

;********
SUBB_A_R0           PROC     NEAR
;********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R0_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_R0           ENDP

;*********************************************************

;********
SUBB_A_R1           PROC     NEAR
;********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R1_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_R1           ENDP

;*********************************************************

;********
SUBB_A_R2           PROC     NEAR
;********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R2_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_R2           ENDP

;*********************************************************

;********
SUBB_A_R3           PROC     NEAR
;********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R3_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_R3           ENDP

;*********************************************************

;********
SUBB_A_R4           PROC     NEAR
;********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R4_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_R4           ENDP

;*********************************************************

;********
SUBB_A_R5           PROC     NEAR
;********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R5_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_R5           ENDP

;*********************************************************

;********
SUBB_A_R6           PROC     NEAR
;********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R6_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_R6           ENDP

;*********************************************************

;********
SUBB_A_R7           PROC     NEAR
;********
                    MOV      AX, OFFSET SUBB_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R7_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SUBB_A_R7           ENDP

;*********************************************************

;*********
ORL_C_NBIT          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ORL_STR
                    MOV      CX, OFFSET C_STR
                    MOV      DX, OFFSET _NOT_STR
                    MOV      BX, BP_BIT_TYPE
                    RET
;                   ********************

ORL_C_NBIT          ENDP

;*********************************************************

;*****
AJMP_5              PROC     NEAR
;*****
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 5
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET AJMP_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, AJMP_TYPE
                    RET
;                   ********************

AJMP_5              ENDP

;*********************************************************

;********
MOV_C_BIT           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET C_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_BIT_TYPE
                    RET
;                   ********************

MOV_C_BIT           ENDP

;*********************************************************

;*******
INC_DPTR            PROC     NEAR
;*******
                    MOV      AX, OFFSET INC_STR
                    MOV      CX, OFFSET DPTR_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

INC_DPTR            ENDP

;*********************************************************

;****
MUL_A               PROC     NEAR
;****
                    MOV      AX, OFFSET MUL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MUL_A               ENDP

;*********************************************************

;******
DB_0A5H             PROC     NEAR
;******
                    MOV      AX, OFFSET DB_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, 0A5H
                    MOV      BX, BP_BYTE_IMM_TYPE
                    RET
;                   ********************

DB_0A5H             ENDP

;*********************************************************

;************
MOV_AT_R0_DIR       PROC     NEAR
;************
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET AT_R0_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_AT_R0_DIR       ENDP

;*********************************************************

;************
MOV_AT_R1_DIR       PROC     NEAR
;************
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET AT_R1_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_AT_R1_DIR       ENDP

;*********************************************************

;*********
MOV_R0_DIR          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R0_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_R0_DIR          ENDP

;*********************************************************

;*********
MOV_R1_DIR          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R1_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_R1_DIR          ENDP

;*********************************************************

;*********
MOV_R2_DIR          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R2_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_R2_DIR          ENDP

;*********************************************************

;*********
MOV_R3_DIR          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R3_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_R3_DIR          ENDP

;*********************************************************

;*********
MOV_R4_DIR          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R4_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_R4_DIR          ENDP

;*********************************************************

;*********
MOV_R5_DIR          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R5_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_R5_DIR          ENDP

;*********************************************************

;*********
MOV_R6_DIR          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R6_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_R6_DIR          ENDP

;*********************************************************

;*********
MOV_R7_DIR          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R7_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_R7_DIR          ENDP

;*********************************************************

;*********
ANL_C_NBIT          PROC     NEAR
;*********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET ANL_STR
                    MOV      CX, OFFSET C_STR
                    MOV      DX, OFFSET _NOT_STR
                    MOV      BX, BP_BIT_TYPE
                    RET
;                   ********************

ANL_C_NBIT          ENDP

;*********************************************************

;******
ACALL_5             PROC     NEAR
;******
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 5
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ACALL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, ACALL_TYPE
                    RET
;                   ********************

ACALL_5             ENDP

;*********************************************************

;******
CPL_BIT             PROC     NEAR
;******
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET CPL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_BIT_TYPE
                    RET
;                   ********************

CPL_BIT             ENDP

;*********************************************************

;****
CPL_C               PROC     NEAR
;****
                    MOV      AX, OFFSET CPL_STR
                    MOV      CX, OFFSET C_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

CPL_C               ENDP

;*********************************************************

;*************
CJNE_A_IMM_REL      PROC     NEAR
;*************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET A_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_A_IMM_REL      ENDP

;*********************************************************

;*************
CJNE_A_DIR_REL      PROC     NEAR
;*************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET A__STR
                    MOV      BX, DL_DIR_BP_REL_TYPE
                    RET
;                   ********************

CJNE_A_DIR_REL      ENDP

;*********************************************************

;*****************
CJNE_AT_R0_IMM_REL  PROC     NEAR
;*****************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET AT_R0_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_AT_R0_IMM_REL  ENDP

;*********************************************************

;*****************
CJNE_AT_R1_IMM_REL  PROC     NEAR
;*****************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET AT_R1_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_AT_R1_IMM_REL  ENDP

;*********************************************************

;**************
CJNE_R0_IMM_REL     PROC     NEAR
;**************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET R0_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_R0_IMM_REL     ENDP

;*********************************************************

;**************
CJNE_R1_IMM_REL     PROC     NEAR
;**************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET R1_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_R1_IMM_REL     ENDP

;*********************************************************

;**************
CJNE_R2_IMM_REL     PROC     NEAR
;**************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET R2_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_R2_IMM_REL     ENDP

;*********************************************************

;**************
CJNE_R3_IMM_REL     PROC     NEAR
;**************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET R3_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_R3_IMM_REL     ENDP

;*********************************************************

;**************
CJNE_R4_IMM_REL     PROC     NEAR
;**************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET R4_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_R4_IMM_REL     ENDP

;*********************************************************

;**************
CJNE_R5_IMM_REL     PROC     NEAR
;**************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET R5_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_R5_IMM_REL     ENDP

;*********************************************************

;**************
CJNE_R6_IMM_REL     PROC     NEAR
;**************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET R6_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_R6_IMM_REL     ENDP

;*********************************************************

;**************
CJNE_R7_IMM_REL     PROC     NEAR
;**************
                    LODSB
                    MOV      AH, 0
                    MOV      DX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET CJNE_STR
                    MOV      CX, OFFSET R7_IMM_STR
                    MOV      BX, DL_IMM_BP_REL_TYPE
                    RET
;                   ********************

CJNE_R7_IMM_REL     ENDP

;*********************************************************

;*******
PUSH_DIR            PROC     NEAR
;*******
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET PUSH_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

PUSH_DIR            ENDP

;*********************************************************

;*****
AJMP_6              PROC     NEAR
;*****
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 6
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET AJMP_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, AJMP_TYPE
                    RET
;                   ********************

AJMP_6              ENDP

;*********************************************************

;******
CLR_BIT             PROC     NEAR
;******
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET CLR_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_BIT_TYPE
                    RET
;                   ********************

CLR_BIT             ENDP

;*********************************************************

;****
CLR_C               PROC     NEAR
;****
                    MOV      AX, OFFSET CLR_STR
                    MOV      CX, OFFSET C_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

CLR_C               ENDP

;*********************************************************

;*****
SWAP_A              PROC     NEAR
;*****
                    MOV      AX, OFFSET SWAP_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SWAP_A              ENDP

;*********************************************************

;********
XCH_A_DIR           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

XCH_A_DIR           ENDP

;*********************************************************

;**********
XCH_A_AT_R0         PROC     NEAR
;**********
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_AT_R0         ENDP

;*********************************************************

;**********
XCH_A_AT_R1         PROC     NEAR
;**********
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_AT_R1         ENDP

;*********************************************************

;*******
XCH_A_R0            PROC     NEAR
;*******
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R0_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_R0            ENDP

;*********************************************************

;*******
XCH_A_R1            PROC     NEAR
;*******
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R1_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_R1            ENDP

;*********************************************************

;*******
XCH_A_R2            PROC     NEAR
;*******
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R2_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_R2            ENDP

;*********************************************************

;*******
XCH_A_R3            PROC     NEAR
;*******
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R3_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_R3            ENDP

;*********************************************************

;*******
XCH_A_R4            PROC     NEAR
;*******
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R4_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_R4            ENDP

;*********************************************************

;*******
XCH_A_R5            PROC     NEAR
;*******
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R5_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_R5            ENDP

;*********************************************************

;*******
XCH_A_R6            PROC     NEAR
;*******
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R6_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_R6            ENDP

;*********************************************************

;*******
XCH_A_R7            PROC     NEAR
;*******
                    MOV      AX, OFFSET XCH_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R7_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCH_A_R7            ENDP

;*********************************************************

;******
POP_DIR             PROC     NEAR
;******
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET POP_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

POP_DIR             ENDP

;*********************************************************

;******
ACALL_6             PROC     NEAR
;******
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 6
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ACALL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, ACALL_TYPE
                    RET
;                   ********************

ACALL_6             ENDP

;*********************************************************

;*******
SETB_BIT            PROC     NEAR
;*******
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET SETB_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BX, BP_BIT_TYPE
                    RET
;                   ********************

SETB_BIT            ENDP

;*********************************************************

;*****
SETB_C              PROC     NEAR
;*****
                    MOV      AX, OFFSET SETB_STR
                    MOV      CX, OFFSET C_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

SETB_C              ENDP

;*********************************************************

;***
DA_A                PROC     NEAR
;***
                    MOV      AX, OFFSET DA_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

DA_A                ENDP

;*********************************************************

;***********
DJNZ_DIR_REL        PROC     NEAR
;***********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET DJNZ_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, CL_DIR_BP_REL_TYPE
                    RET
;                   ********************

DJNZ_DIR_REL        ENDP

;*********************************************************

;***********
XCHD_A_AT_R0        PROC     NEAR
;***********
                    MOV      AX, OFFSET XCHD_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCHD_A_AT_R0        ENDP

;*********************************************************

;***********
XCHD_A_AT_R1        PROC     NEAR
;***********
                    MOV      AX, OFFSET XCHD_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

XCHD_A_AT_R1        ENDP

;*********************************************************

;**********
DJNZ_R0_REL         PROC     NEAR
;**********
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET DJNZ_STR
                    MOV      CX, OFFSET R0_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

DJNZ_R0_REL         ENDP

;*********************************************************

;**********
DJNZ_R1_REL         PROC     NEAR
;**********
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET DJNZ_STR
                    MOV      CX, OFFSET R1_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

DJNZ_R1_REL         ENDP

;*********************************************************

;**********
DJNZ_R2_REL         PROC     NEAR
;**********
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET DJNZ_STR
                    MOV      CX, OFFSET R2_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

DJNZ_R2_REL         ENDP

;*********************************************************

;**********
DJNZ_R3_REL         PROC     NEAR
;**********
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET DJNZ_STR
                    MOV      CX, OFFSET R3_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

DJNZ_R3_REL         ENDP

;*********************************************************

;**********
DJNZ_R4_REL         PROC     NEAR
;**********
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET DJNZ_STR
                    MOV      CX, OFFSET R4_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

DJNZ_R4_REL         ENDP

;*********************************************************

;**********
DJNZ_R5_REL         PROC     NEAR
;**********
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET DJNZ_STR
                    MOV      CX, OFFSET R5_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

DJNZ_R5_REL         ENDP

;*********************************************************

;**********
DJNZ_R6_REL         PROC     NEAR
;**********
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET DJNZ_STR
                    MOV      CX, OFFSET R6_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

DJNZ_R6_REL         ENDP

;*********************************************************

;**********
DJNZ_R7_REL         PROC     NEAR
;**********
                    LODSB
                    CBW
                    ADD      AX, SI
                    SUB      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX
                    MOV      AX, OFFSET DJNZ_STR
                    MOV      CX, OFFSET R7_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_REL_TYPE
                    RET
;                   ********************

DJNZ_R7_REL         ENDP

;*********************************************************

;*************
MOVX_A_AT_DPTR      PROC     NEAR
;*************
                    MOV      AX, OFFSET MOVX_STR
                    MOV      CX, OFFSET A_AT_DPTR_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOVX_A_AT_DPTR      ENDP

;*********************************************************

;*****
AJMP_7              PROC     NEAR
;*****
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 7
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET AJMP_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, AJMP_TYPE
                    RET
;                   ********************

AJMP_7              ENDP

;*********************************************************

;***********
MOVX_A_AT_R0        PROC     NEAR
;***********
                    MOV      AX, OFFSET MOVX_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOVX_A_AT_R0        ENDP

;*********************************************************

;***********
MOVX_A_AT_R1        PROC     NEAR
;***********
                    MOV      AX, OFFSET MOVX_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOVX_A_AT_R1        ENDP

;*********************************************************

;****
CLR_A               PROC     NEAR
;****
                    MOV      AX, OFFSET CLR_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

CLR_A               ENDP

;*********************************************************

;********
MOV_A_DIR           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      BP, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BX, BP_DIR_TYPE
                    RET
;                   ********************

MOV_A_DIR           ENDP

;*********************************************************

;**********
MOV_A_AT_R0         PROC     NEAR
;**********
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_AT_R0_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_AT_R0         ENDP

;*********************************************************

;**********
MOV_A_AT_R1         PROC     NEAR
;**********
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_AT_R1_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_AT_R1         ENDP

;*********************************************************

;*******
MOV_A_R0            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R0_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_R0            ENDP

;*********************************************************

;*******
MOV_A_R1            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R1_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_R1            ENDP

;*********************************************************

;*******
MOV_A_R2            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R2_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_R2            ENDP

;*********************************************************

;*******
MOV_A_R3            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R3_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_R3            ENDP

;*********************************************************

;*******
MOV_A_R4            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R4_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_R4            ENDP

;*********************************************************

;*******
MOV_A_R5            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R5_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_R5            ENDP

;*********************************************************

;*******
MOV_A_R6            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R6_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_R6            ENDP

;*********************************************************

;*******
MOV_A_R7            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET R7_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_A_R7            ENDP

;*********************************************************

;*************
MOVX_AT_DPTR_A      PROC     NEAR
;*************
                    MOV      AX, OFFSET MOVX_STR
                    MOV      CX, OFFSET AT_DPTR_A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOVX_AT_DPTR_A      ENDP

;*********************************************************

;******
ACALL_7             PROC     NEAR
;******
                    MOV      AX, SI
                    AND      AH, 11111000B
                    OR       AH, 7
                    LODSB
                    MOV      BP, AX
                    MOV      AX, OFFSET ACALL_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      CX, OFFSET NUL_STR
                    MOV      BX, ACALL_TYPE
                    RET
;                   ********************

ACALL_7             ENDP

;*********************************************************

;***********
MOVX_AT_R0_A        PROC     NEAR
;***********
                    MOV      AX, OFFSET MOVX_STR
                    MOV      CX, OFFSET AT_R0_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOVX_AT_R0_A        ENDP

;*********************************************************

;***********
MOVX_AT_R1_A        PROC     NEAR
;***********
                    MOV      AX, OFFSET MOVX_STR
                    MOV      CX, OFFSET AT_R1_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOVX_AT_R1_A        ENDP

;*********************************************************

;****
CPL_A               PROC     NEAR
;****
                    MOV      AX, OFFSET CPL_STR
                    MOV      CX, OFFSET A_STR
                    MOV      DX, OFFSET NUL_STR
                    MOV      BP, OFFSET NUL_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

CPL_A               ENDP

;*********************************************************

;********
MOV_DIR_A           PROC     NEAR
;********
                    LODSB
                    MOV      AH, 0
                    MOV      CX, AX
                    MOV      AX, OFFSET MOV_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, CL_DIR_TYPE
                    RET
;                   ********************

MOV_DIR_A           ENDP

;*********************************************************

;**********
MOV_AT_R0_A         PROC     NEAR
;**********
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET AT_R0_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_AT_R0_A         ENDP

;*********************************************************

;**********
MOV_AT_R1_A         PROC     NEAR
;**********
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET AT_R1_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_AT_R1_A         ENDP

;*********************************************************

;*******
MOV_R0_A            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R0_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_R0_A            ENDP

;*********************************************************

;*******
MOV_R1_A            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R1_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_R1_A            ENDP

;*********************************************************

;*******
MOV_R2_A            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R2_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_R2_A            ENDP

;*********************************************************

;*******
MOV_R3_A            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R3_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_R3_A            ENDP

;*********************************************************

;*******
MOV_R4_A            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R4_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_R4_A            ENDP

;*********************************************************

;*******
MOV_R5_A            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R5_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_R5_A            ENDP

;*********************************************************

;*******
MOV_R6_A            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R6_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_R6_A            ENDP

;*********************************************************

;*******
MOV_R7_A            PROC     NEAR
;*******
                    MOV      AX, OFFSET MOV_STR
                    MOV      CX, OFFSET R7_STR
                    MOV      DX, OFFSET _STR
                    MOV      BP, OFFSET A_STR
                    MOV      BX, NO_DATA
                    RET
;                   ********************

MOV_R7_A            ENDP

;*********************************************************

                    PUBLIC   UN51
;***
UN51                PROC     NEAR
;***
                    CALL     INITIALIZE

                    CALL     READ_HEX

                    CALL     BUILD_MAPS

                    CALL     OUTPUT_EQUATES

                    MOV      [ PREVIOUS_ADDRESS ], -1
                    MOV      SI, 0

LOW_LAB_LOOP:       CMP      SI, [ LOWEST_ADDRESS ]
                    JZ       START_DIS

                    CALL     GEN_LABELS
                    CMP      [ COLUMN ], 0
                    JZ       LOW_LABS

                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET EQU_STR
                    CALL     PRINT_DX
                    CALL     TO_PARAMETERS
                    MOV      AX, SI
                    CALL     HEX_WORD
                    CALL     NEW_LINE

LOW_LABS:           INC      SI
                    JMP      LOW_LAB_LOOP
;                   ********************

START_DIS:          CALL     OUTPUT_ORG

DIS_LOOP:           CALL     NEW_LINE
                    CALL     GEN_LABELS
                    CALL     TO_INSTRUCTION

                    PUSH     SI
                    CALL     DIS_VECTOR
                    POP      DI
                    CALL     PRINT_AX

                    CALL     TO_PARAMETERS
                    PUSH     BX
                    CALL     [ OUTPUT_TABLE.BX ]
                    POP      BX
                    JC       DIS_BAR

                    JZ       DIS_FOLLOW_CHECK

                    CALL     NEW_LINE
                    JMP      DIS_END_CHECK
;                   ********************

DIS_BAR:            CALL     MAKE_BAR
                    CALL     CHECK_CODE_ADDRESS
                    JNZ      DIS_END_CHECK

                    CALL     NEW_LINE
                    MOV      DX, OFFSET LONG_BAR ;switch to data mode
                    CALL     PRINT_DX                    

DIS_HEX_LOOP:       CALL     NEW_LINE
                    CALL     GEN_LABELS
                    CALL     TO_INSTRUCTION

                    CALL     GEN_DIS_HEX
                    CALL     CHECK_CODE_ADDRESS
                    JZ       HEX_END_CHECK

                    CALL     NEW_LINE
                    CALL     NEW_LINE
                    MOV      DX, OFFSET LONG_BAR ;switch to code mode
                    CALL     PRINT_DX
                    JMP      DIS_END_CHECK
;                   ********************

HEX_END_CHECK:      CMP      SI, [ HIGHEST_ADDRESS ]
                    JB       DIS_HEX_LOOP

                    JMP      DIS_HEX_DNE
;                   ********************

DIS_FOLLOW_CHECK:   CALL     HANDLE_FOLLOWING

DIS_END_CHECK:      CMP      SI, [ HIGHEST_ADDRESS ]
                    JB       DIS_LOOP

DIS_HEX_DNE:        CALL     NEW_LINE

HIGH_LAB_LOOP:      CMP      SI, 0
                    JZ       END_DIS

                    CALL     GEN_LABELS
                    CMP      [ COLUMN ], 0
                    JZ       HIGH_LABS

                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET EQU_STR
                    CALL     PRINT_DX
                    CALL     TO_PARAMETERS
                    MOV      AX, SI
                    CALL     HEX_WORD
                    CALL     NEW_LINE

HIGH_LABS:          INC      SI
                    JMP      HIGH_LAB_LOOP
;                   ********************

END_DIS:            CALL     NEW_LINE
                    CALL     NEW_LINE
                    MOV      DX, OFFSET LONG_BAR
                    CALL     PRINT_DX
                    CALL     NEW_LINE
                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET END_STR
                    CALL     PRINT_DX
                    CALL     NEW_LINE
                    CALL     NEW_LINE

                    XOR      AX, AX
                    MOV      AH, TERMINATE
                    INT      DOS_FUNCTION
;                   ********************

UN51                ENDP

;*********************************************************

                    PUBLIC   HANDLE_FOLLOWING
;***************
HANDLE_FOLLOWING    PROC     NEAR
;***************
                    CMP      BX, ACALL_TYPE
                    JZ       HF_ACALL

                    CMP      BX, LCALL_TYPE
                    JNZ      HF_DNE

HF_ACALL:           MOV      DI, OFFSET FOLLOWING_LIST

HF_LIST_LOOP:       MOV      AX, WORD PTR MAP_SEG:[ DI ]
                    CMP      AX, -1
                    JZ       HF_SPECIAL

                    INC      DI
                    INC      DI
                    MOV      BL, BYTE PTR MAP_SEG:[ DI ]
                    INC      DI
                    CMP      AX, BP
                    JNZ      HF_LIST_LOOP

                    XOR      CH, CH
                    MOV      CL, BL

HF_FIXED_LOOP:      PUSH     CX
                    CALL     HEX_BYTE_SUB
                    POP      CX
                    LOOP     HF_FIXED_LOOP

                    JMP      HF_B4
;                   ********************

HF_SPECIAL:         
                    IF       NOT VARIABLE_BYTE_FOLLOWING

                    JMP      HF_DNE
;                   ********************

                    ELSE

;  this is code I wrote to disassemble the firmware of an
;  OKIDATA printer, which used byte following subroutine
;  calls where the high order bits of the first byte following
;  the call determined the number of remaining bytes following
;  the call before code resumed.

;  if you encounter this ugly coding technique (i've always
;  found a cleaner way to do what I wanted which was both
;  faster and smaller than this approach), you should write
;  your own code here to disassemble the way you like.

                    CMP      BP, BYTE_FOLLOWING_SUB
                    JNZ      HF_DNE

                    CALL     NEW_LINE
                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET DB_STR
                    CALL     PRINT_DX
                    CALL     TO_PARAMETERS
                    LODSB
                    PUSH     AX
                    CALL     HEX_BYTE
                    POP      AX
                    TEST     AL, 10000000B
                    JNZ      HF_B7

                    TEST     AL, 01000000B
                    JNZ      HF_B6

                    PUSH     AX
                    CALL     HEX_WORD_SUB
                    POP      AX
                    JMP      HF_B7
;                   ********************

                    ENDIF

HF_B6:              PUSH     AX
                    CALL     HEX_BYTE_SUB
                    POP      AX

HF_B7:              TEST     AL, 00010000B
                    JNZ      HF_B4

                    TEST     AL, 00001000B
                    JNZ      HF_B3

                    CALL     HEX_WORD_SUB
                    JMP      HF_B4
;                   ********************

HF_B3:              CALL     HEX_BYTE_SUB

HF_B4:              CALL     NEW_LINE

                    AND      AL, FALSE

HF_DNE:             RET
;                   ********************

HANDLE_FOLLOWING    ENDP

;*********************************************************

                    PUBLIC   HEX_BYTE_SUB
;***********
HEX_BYTE_SUB        PROC     NEAR
;***********
                    CALL     NEW_LINE
                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET DB_STR
                    CALL     PRINT_DX
                    CALL     TO_PARAMETERS
                    LODSB
                    JMP      HEX_BYTE
;                   ********************

HEX_BYTE_SUB        ENDP

;*********************************************************

                    PUBLIC   HEX_WORD_SUB
;***********
HEX_WORD_SUB        PROC     NEAR
;***********
                    CALL     NEW_LINE
                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET DW_STR
                    CALL     PRINT_DX
                    CALL     TO_PARAMETERS
                    LODSW
                    XCHG     AH, AL
                    JMP      HEX_WORD
;                   ********************

HEX_WORD_SUB        ENDP

;*********************************************************

                    PUBLIC   GEN_DIS_HEX
;**********
GEN_DIS_HEX         PROC     NEAR
;**********
                    MOV      DX, OFFSET DB_STR
                    CALL     PRINT_DX
                    CALL     TO_PARAMETERS
                   PUSH     SI
                    LODSB
                   POP      SI
                    CALL     HEX_BYTE
                    MOV      AX, DB_INSTRUCTION_COLUMN
                    CALL     SPACE_TO_COLUMN
                    MOV      AL, ';'
                    CALL     PRINT_AL
                   PUSH     SI
                    CALL     DIS_VECTOR
                    CALL     PRINT_AX
                    MOV      AX, DB_PARAMETERS_COLUMN
                    CALL     SPACE_TO_COLUMN
                   POP      DI
                   PUSH     DI
                    CALL     [ OUTPUT_TABLE.BX ]
                   POP      SI
                    INC      SI                    
                    RET
;                   ********************

GEN_DIS_HEX         ENDP

;*********************************************************

                    PUBLIC   OUTPUT_EQUATES
;*************
OUTPUT_EQUATES      PROC     NEAR
;*************
                    XOR      AX, AX

OE_DIR_LOOP:        PUSH     AX
                    MOV      BP, AX
                    CALL     TEST_DR_MAP
                    JZ       OE_SKIP_DIR

                    POP      AX
                    PUSH     AX
                    CALL     AX_DIR_GEN
                    JZ       OE_SKIP_DIR

                    MOV      AL, ':'
                    CALL     PRINT_AL
                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET EQU_STR
                    CALL     PRINT_DX
                    CALL     TO_PARAMETERS
                    POP      AX
                    PUSH     AX
                    CALL     HEX_BYTE
                    CALL     NEW_LINE

OE_SKIP_DIR:        POP      AX
                    INC      AL
                    JNZ      OE_DIR_LOOP

                    CALL     NEW_LINE
                    MOV      DX, OFFSET LONG_BAR
                    CALL     PRINT_DX
                    JMP      NEW_LINE
;                   ********************

OUTPUT_EQUATES      ENDP

;*********************************************************

                    PUBLIC   OUTPUT_ORG
;*********
OUTPUT_ORG          PROC     NEAR
;*********
                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET ORG_STR
                    CALL     PRINT_DX
                    CALL     TO_PARAMETERS
                    MOV      AX, [ LOWEST_ADDRESS ]
                    CALL     HEX_WORD
                    CALL     NEW_LINE
                    JMP      NEW_LINE
;                   ********************

OUTPUT_ORG          ENDP

;*********************************************************

                    PUBLIC   BUILD_MAPS, BUILD_LOOP, MAP_LOOP, MAP_FOLLOW
                    PUBLIC   MAP_FOLLOW_LOOP, MAPF_SPECIAL
                    PUBLIC   MAP_DATA_LOOP, BM_DNE
;*********
BUILD_MAPS          PROC     NEAR
;*********

BUILD_LOOP:         MOV      SI, [ LOWEST_ADDRESS ]
                    MOV      [ MAPS_CHANGED_FLAG ], FALSE

MAP_LOOP:           CMP      SI, [ HIGHEST_ADDRESS ]
                    JNB      BM_DNE

                    CALL     DIS_VECTOR
                    PUSH     BX
                    PUSH     BP
                    CALL     [ INPUT_TABLE.BX ]
                    POP      BP
                    POP      BX
                    JC       MAP_DATA_LOOP  ;switch to data mode?

                    CMP      BX, ACALL_TYPE
                    JZ       MAP_FOLLOW

                    CMP      BX, LCALL_TYPE
                    JNZ      MAP_LOOP

MAP_FOLLOW:         MOV      DI, OFFSET FOLLOWING_LIST

MAP_FOLLOW_LOOP:    MOV      AX, WORD PTR MAP_SEG:[ DI ]
                    CMP      AX, -1
                    JZ       MAPF_SPECIAL

                    INC      DI
                    INC      DI
                    MOV      BL, BYTE PTR MAP_SEG:[ DI ]
                    INC      DI
                    CMP      BP, AX
                    JNZ      MAP_FOLLOW_LOOP

                    XOR      BH, BH
                    ADD      BX, SI
                    MOV      SI, BX                    
                    JMP      MAP_LOOP
;                   ********************

MAPF_SPECIAL:
                    IF       NOT VARIABLE_BYTE_FOLLOWING

                    JMP      MAP_LOOP
;                   ********************

                    ELSE

;  If you have written code handle special case disassembly of
;  byte following subroutine calls, you must write the appropriate
;  code here to consume the right number of bytes so that code
;  and data are correctly identified.

                    CMP      BP, BYTE_FOLLOWING_SUB  ;is this the special one?
                    JNZ      MAP_LOOP

                    LODSB
                    MOV      AH, AL
                    TEST     AH, 10000000B
                    JNZ      BF_7

                    TEST     AH, 01000000B
                    JNZ      BF_6

                    LODSB

BF_6:               LODSB

BF_7:               TEST     AH, 00010000B
                    JNZ      BF_4

                    TEST     AH, 00001000B
                    JNZ      BF_3

                    LODSB

BF_3:               LODSB

BF_4:               JMP      MAP_LOOP
;                   ********************

                    ENDIF

BM_DNE:             CMP      [ MAPS_CHANGED_FLAG ], FALSE
                    JNZ      BUILD_LOOP

                    RET
;                   ********************

MAP_DATA_LOOP:      CALL     CHECK_CODE_ADDRESS
                    JNZ      MAP_LOOP  ;switch to code mode

                    INC      SI
                    CMP      SI, [ HIGHEST_ADDRESS ]
                    JNB      BM_DNE

                    JMP      MAP_DATA_LOOP
;                   ********************

BUILD_MAPS          ENDP

;*********************************************************

                    PUBLIC   READ_HEX
;*******
READ_HEX            PROC     NEAR
;*******
                    MOV      [ LOWEST_ADDRESS ], -1
                    MOV      [ HIGHEST_ADDRESS ], 0

                    PUBLIC   RECORD_LOOP
RECORD_LOOP:        CALL     KEY
                    CMP      AL, '+'
                    JNZ      RLNP

                    CALL     GET_WORD
                    MOV      [ FUDGE_FACTOR ], AX
                    JMP      RECORD_LOOP
;                   ********************

RLNP:               CMP      AL, '-'
                    JNZ      RLNM

                    CALL     GET_WORD
                    NEG      AX
                    MOV      [ FUDGE_FACTOR ], AX
                    JMP      RECORD_LOOP
;                   ********************

RLNM:               CMP      AL, ":"        ;******
                    JNZ      RECORD_LOOP

                    CALL     GET_BYTE       ;length byte
                    CBW
                    MOV      CX, AX         ;CX=#of data bytes
                    MOV      DX, AX         ;DX=chksum

                    CALL     GET_BYTE       ;hi address
                    ADD      DL, AL
                    MOV      BH, AL
                    CALL     GET_BYTE       ;lo address
                    ADD      DL, AL
                    MOV      BL, AL         ;BX=address

                    CALL     GET_BYTE       ;intel record type#
                    ADD      DL, AL
                    OR       AL, AL
                    JNZ      CHK_FOR_END

                    ADD      BX, [ FUDGE_FACTOR ]

                    PUBLIC   DATA_LOOP
DATA_LOOP:          CALL     GET_BYTE       ;data
                    ADD      DL, AL

                    CMP      BX, [ HIGHEST_ADDRESS ]
                    JB       LOWER_ADDRESS

                    MOV      [ HIGHEST_ADDRESS ], BX

LOWER_ADDRESS:      CMP      BX, [ LOWEST_ADDRESS ]
                    JNB      HIGHER_ADDRESS

                    MOV      [ LOWEST_ADDRESS ], BX

HIGHER_ADDRESS:     MOV      [ OBJ_BUFFER.BX ], AL
                    INC      BX

                    LOOP     DATA_LOOP

                    CALL     GET_BYTE       ;checksum byte
                    ADD      DL, AL
                    JZ       RECORD_LOOP

                    MOV      DX, OFFSET BAD_CHECKSUM

                    PUBLIC   FATAL_ERROR
;**********
FATAL_ERROR         PROC     NEAR
;**********
                    CALL     PRINT_DX

                    MOV      AX, 1
                    MOV      AH, TERMINATE
                    INT      DOS_FUNCTION
;                   ********************

FATAL_ERROR         ENDP

                    PUBLIC   CHK_FOR_END
CHK_FOR_END:        MOV      DX, OFFSET UNDEFINED_RECORD
                    DEC      AL
                    JNZ      FATAL_ERROR

                    ADD      [ HIGHEST_ADDRESS ], OFFSET OBJ_BUFFER + 1
                    ADD      [ LOWEST_ADDRESS ], OFFSET OBJ_BUFFER
                    MOV      DI, OFFSET FOLLOWING_LIST

CFE_LOOP1:          CALL     GET_KEY
                    JZ       CFE_EOF

                    CMP      AL, '>'
                    JZ       CFE_OR_DATA

                    CMP      AL, '#'
                    JNZ      CFE_LOOP1

                    CALL     GET_WORD
                    ADD      AX, OFFSET OBJ_BUFFER
                    MOV      WORD PTR MAP_SEG:[ DI ], AX
                    INC      DI
                    INC      DI

                    CALL     GET_KEY
                    CALL     GET_BYTE
                    MOV      BYTE PTR MAP_SEG:[ DI], AL
                    INC      DI
                    JMP      CFE_LOOP1
;                   ********************

CFE_OR_DATA:        CALL     GET_WORD
                    ADD      AX, OFFSET OBJ_BUFFER
                    MOV      BP, AX

                    CALL     SET_OR_MAP
                    JMP      CFE_LOOP1
;                   ********************

CFE_EOF:            MOV      WORD PTR MAP_SEG:[ DI ], -1
                    RET
;                   ********************

READ_HEX            ENDP

;*********************************************************

                    PUBLIC   INITIALIZE
;*********
INITIALIZE          PROC     NEAR
;*********
                    CLD      ;clear direction flag

                    MOV      AX, SEG OBJ_SEG
                    MOV      DS, AX
                    MOV      ES, AX
                    XOR      CX, CX
                    MOV      DI, CX
                    MOV      AL, -1
                    REP      STOSB

                    MOV      AX, SEG MAP_SEG
                    MOV      ES, AX

                    XOR      AX, AX
                    MOV      DI, AX
                    MOV      CX, ( END_OF_MAPS - START_OF_MAPS )
                    REP      STOSB

                    MOV      DX, OFFSET OPENING_TEXT
                    CALL     PRINT_DX
                    CALL     NEW_LINE

                    RET
;                   ********************

INITIALIZE          ENDP

;*********************************************************

;*******
GET_WORD            PROC     NEAR
;*******
                    PUSH     BX
                    CALL     GET_BYTE
                    PUSH     AX
                    CALL     GET_BYTE
                    POP      BX
                    MOV      AH, BL
                    POP      BX
                    RET
;                   ********************

GET_WORD            ENDP

;*********************************************************

                    PUBLIC   CHECK_CODE_ADDRESS
;*****************
CHECK_CODE_ADDRESS  PROC     NEAR
;*****************
                    MOV      DI, SI
                    CMP      DI, 36
                    JNB      CCA_NOT_HARDWARE

                    CMP      DI, 000H
                    JZ       CCA_TRUE

                    CMP      DI, 003H
                    JZ       CCA_TRUE

                    CMP      DI, 00BH
                    JZ       CCA_TRUE

                    CMP      DI, 013H
                    JZ       CCA_TRUE

                    CMP      DI, 01BH
                    JZ       CCA_TRUE

                    CMP      DI, 023H
                    JNZ      CCA_NOT_HARDWARE

CCA_TRUE:           OR       AL, -1
                    RET
;                   ********************

CCA_NOT_HARDWARE:   MOV      BP, DI
                    CALL     TEST_OR_MAP
                    JNZ      CCA_TRUE

                    MOV      BP, DI
                    CALL     TEST_RL_MAP
                    JNZ      CCA_TRUE

                    MOV      BP, DI
                    CALL     TEST_AJ_MAP
                    JNZ      CCA_TRUE

                    MOV      BP, DI
                    CALL     TEST_LJ_MAP
                    JNZ      CCA_TRUE

                    MOV      BP, DI
                    CALL     TEST_AC_MAP
                    JNZ      CCA_TRUE

                    MOV      BP, DI
                    CALL     TEST_LC_MAP
                    JNZ      CCA_TRUE

                    RET
;                   ********************

CHECK_CODE_ADDRESS  ENDP

;*********************************************************

                    PUBLIC   GEN_LABELS
;*********
GEN_LABELS          PROC     NEAR
;*********
                    XCHG     SI, [ PREVIOUS_ADDRESS ]

GL_LOOP:            INC      SI
                    CMP      SI, 35 + 1
                    JNB      GL_NOT_HARDWARE  ;just for speed

                    CALL     GEN_HARDWARE

GL_NOT_HARDWARE:    MOV      BP, SI
                    CALL     TEST_OR_MAP
                    JZ       TOR_DNE

                    MOV      BP, SI
                    MOV      BX, OFFSET OR_LAB
                    CALL     GENERATE_LABEL

TOR_DNE:            MOV      BP, SI
                    CALL     TEST_RL_MAP
                    JZ       TRL_DNE

                    MOV      BP, SI
                    MOV      BX, OFFSET RL_LAB
                    CALL     GENERATE_LABEL

TRL_DNE:            MOV      BP, SI
                    CALL     TEST_AJ_MAP
                    JZ       TAJ_DNE

                    MOV      BP, SI
                    MOV      BX, OFFSET AJ_LAB
                    CALL     GENERATE_LABEL

TAJ_DNE:            MOV      BP, SI
                    CALL     TEST_LJ_MAP
                    JZ       TLJ_DNE

                    MOV      BP, SI
                    MOV      BX, OFFSET LJ_LAB
                    CALL     GENERATE_LABEL

TLJ_DNE:            MOV      BP, SI
                    CALL     TEST_AC_MAP
                    JZ       TAC_DNE

                    MOV      BP, SI
                    MOV      BX, OFFSET AC_LAB
                    CALL     GENERATE_LABEL

TAC_DNE:            MOV      BP, SI
                    CALL     TEST_LC_MAP
                    JZ       TLC_DNE

                    MOV      BP, SI
                    MOV      BX, OFFSET LC_LAB
                    CALL     GENERATE_LABEL

TLC_DNE:            CMP      SI, [ PREVIOUS_ADDRESS ]
                    JNZ      GL_LOOP

                    RET
;                   ********************

GEN_LABELS          ENDP

;*********************************************************

                    PUBLIC   GEN_HARDWARE
;***********
GEN_HARDWARE        PROC     NEAR
;***********
                    MOV      DX, OFFSET SERIAL_LAB
                    CMP      SI, 35
                    JZ       GL_INTERUPT_VECTOR

                    MOV      DX, OFFSET RESET_LAB
                    CMP      SI, 0
                    JZ       GL_INTERUPT_VECTOR

                    MOV      DX, OFFSET EXT_INT_0__LAB
                    CMP      SI, 3
                    JZ       GL_INTERUPT_VECTOR

                    MOV      DX, OFFSET TIMER_0_LAB
                    CMP      SI, 11
                    JZ       GL_INTERUPT_VECTOR

                    MOV      DX, OFFSET EXT_INT_1_LAB
                    CMP      SI, 19
                    JZ       GL_INTERUPT_VECTOR

                    MOV      DX, OFFSET TIMER_1_LAB
                    CMP      SI, 27
                    JNZ      GH_DNE

GL_INTERUPT_VECTOR: CALL     INTERUPT_LABEL

GH_DNE:             RET
;                   ********************

GEN_HARDWARE        ENDP

;*********************************************************

                    PUBLIC   INTERUPT_LABEL
;*************
INTERUPT_LABEL      PROC     NEAR
;*************
                    PUSH     DX
                    CALL     ASSURE_BLANK_LINE
                    POP      DX

                    CALL     PRINT_DX
                    MOV      BP, SI
                    JMP      FUDGE_LABEL
;                   ********************
                    
INTERUPT_LABEL      ENDP

;*********************************************************

                    PUBLIC   ASSURE_BLANK_LINE
;****************
ASSURE_BLANK_LINE   PROC     NEAR
;****************
                    CMP      [ COLUMN ], 0
                    JNZ      GL_NL

                    CMP      [ BLANK_LINE_FLAG ], FALSE
                    JNZ      GL_OK

GL_NL:              CALL     NEW_LINE

GL_OK:              RET
;                   ********************

ASSURE_BLANK_LINE   ENDP

;*********************************************************

                    PUBLIC   GENERATE_LABEL
;*************
GENERATE_LABEL      PROC     NEAR
;*************
                    CALL     ASSURE_BLANK_LINE
                    MOV      DX, BX
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     HEX_WORD

                    MOV      AL, ':'
                    CALL     PRINT_AL

                    PUBLIC   FUDGE_LABEL
;**********
FUDGE_LABEL         PROC     NEAR
;**********
                    CMP      BP, [ PREVIOUS_ADDRESS ]
                    JZ       GL_DNE

                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET EQU_STR
                    CALL     PRINT_DX
                    CALL     TO_PARAMETERS
                    MOV      DX, OFFSET DOLLAR_MINUS_STR
                    CALL     PRINT_DX
                    MOV      AX, [ PREVIOUS_ADDRESS ]
                    SUB      AX, BP
                    OR       AL, '0'
                    CALL     PRINT_AL
                    CALL     NEW_LINE

GL_DNE:             RET
;                   ********************

FUDGE_LABEL         ENDP
GENERATE_LABEL      ENDP

;*********************************************************

;*******
ONO_DATA            PROC     NEAR
;*******
                    CALL     PRINT_CX
                    CALL     PRINT_DX
                    CALL     PRINT_BP
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

ONO_DATA            ENDP

;*********************************************************

;***********
ONO_DATA_UNC        PROC     NEAR
;***********
                    CALL     PRINT_CX
                    CALL     PRINT_DX
                    CALL     PRINT_BP
                    CALL     DATA_COMMENT
                    STC
                    RET
;                   ********************

ONO_DATA_UNC        ENDP

;*********************************************************

                    PUBLIC   MAKE_BAR
;*******
MAKE_BAR            PROC     NEAR
;*******
                    CALL     NEW_LINE
                    MOV      AL, ';'
                    CALL     PRINT_AL
                    CALL     TO_INSTRUCTION
                    MOV      DX, OFFSET SHORT_BAR
                    JMP      PRINT_DX
;                   ********************

MAKE_BAR            ENDP

;*********************************************************

;*********
OAJMP_TYPE          PROC     NEAR
;*********
                    MOV      BX, OFFSET AJ_LAB
                    CALL     BP_USE
                    CALL     DATA_COMMENT
                    STC
                    RET
;                   ********************

OAJMP_TYPE          ENDP

;*********************************************************

;**********
OACALL_TYPE         PROC     NEAR
;**********
                    MOV      BX, OFFSET AC_LAB
                    CALL     BP_USE
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OACALL_TYPE         ENDP

;*********************************************************

;*********
OLJMP_TYPE          PROC     NEAR
;*********
                    MOV      BX, OFFSET LJ_LAB
                    CALL     BP_USE
                    CALL     DATA_COMMENT
                    STC
                    RET
;                   ********************

OLJMP_TYPE          ENDP

;*********************************************************

;**********
OLCALL_TYPE         PROC     NEAR
;**********
                    MOV      BX, OFFSET LC_LAB
                    CALL     BP_USE
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OLCALL_TYPE         ENDP

;*********************************************************

;***********
OBP_REL_TYPE        PROC     NEAR
;***********
                    MOV      BX, OFFSET RL_LAB
                    CALL     BP_USE
                    CALL     DATA_COMMENT
                    OR       AL, TRUE
                    RET
;                   ********************

OBP_REL_TYPE        ENDP

;*********************************************************

;***************
OBP_REL_UNC_TYPE    PROC     NEAR
;***************
                    MOV      BX, OFFSET RL_LAB
                    CALL     BP_USE
                    CALL     DATA_COMMENT
                    STC
                    RET
;                   ********************

OBP_REL_UNC_TYPE    ENDP

;*********************************************************

;******************
ODL_DIR_BP_REL_TYPE PROC     NEAR
;******************
                    CALL     PRINT_CX
                    MOV      AX, DX
                    CALL     AX_DIR
                    MOV      DX, OFFSET _STR
                    CALL     PRINT_DX
                    MOV      DX, OFFSET RL_LAB
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     HEX_WORD
                    CALL     DATA_COMMENT
                    OR       AL, TRUE
                    RET
;                   ********************

ODL_DIR_BP_REL_TYPE ENDP

;*********************************************************

;******************
OCL_DIR_BP_REL_TYPE PROC     NEAR
;******************
                    MOV      AX, CX
                    CALL     AX_DIR
                    CALL     PRINT_DX
                    MOV      DX, OFFSET RL_LAB
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     HEX_WORD
                    CALL     DATA_COMMENT
                    OR       AL, TRUE
                    RET
;                   ********************

OCL_DIR_BP_REL_TYPE ENDP

;*********************************************************

;******************
ODL_IMM_BP_REL_TYPE PROC     NEAR
;******************
                    CALL     PRINT_CX
                    MOV      AX, DX
                    CALL     HEX_BYTE
                    MOV      DX, OFFSET _STR
                    CALL     PRINT_DX
                    MOV      DX, OFFSET RL_LAB
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     HEX_WORD
                    CALL     DATA_COMMENT
                    OR       AL, TRUE
                    RET
;                   ********************

ODL_IMM_BP_REL_TYPE ENDP

;*********************************************************

;******************
OCL_BIT_BP_REL_TYPE PROC     NEAR
;******************
                    MOV      AX, CX
                    CALL     AX_BIT
                    CALL     PRINT_DX
                    MOV      DX, OFFSET RL_LAB
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     HEX_WORD
                    CALL     DATA_COMMENT
                    OR       AL, TRUE
                    RET
;                   ********************

OCL_BIT_BP_REL_TYPE ENDP

;*********************************************************

                    PUBLIC   NEW_LINE
;*******
NEW_LINE            PROC     NEAR
;*******
                    MOV      DX, OFFSET NEWLINE
                    JMP      PRINT_DX
;                   ********************

NEW_LINE            ENDP

;*********************************************************

                    PUBLIC   OBP_BYTE_IMM_TYPE
;****************
OBP_BYTE_IMM_TYPE   PROC     NEAR
;****************
                    CALL     PRINT_CX
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     HEX_BYTE
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OBP_BYTE_IMM_TYPE   ENDP

;*********************************************************

;****************
OBP_WORD_IMM_TYPE   PROC     NEAR
;****************
                    CALL     PRINT_CX
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     HEX_WORD
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OBP_WORD_IMM_TYPE   ENDP

;*********************************************************

;***********
OBP_BIT_TYPE        PROC     NEAR
;***********
                    CALL     PRINT_CX
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     AX_BIT
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OBP_BIT_TYPE        ENDP

;*********************************************************

;***********
OBP_DIR_TYPE        PROC     NEAR
;***********
                    CALL     PRINT_CX
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     AX_DIR
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OBP_DIR_TYPE        ENDP

;*********************************************************

;***********
OCL_DIR_TYPE        PROC     NEAR 
;***********
                    MOV      AX, CX
                    CALL     AX_DIR
                    CALL     PRINT_DX
                    CALL     PRINT_BP
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OCL_DIR_TYPE        ENDP

;*********************************************************

;***********
OCL_BIT_TYPE        PROC     NEAR
;***********
                    MOV      AX, CX
                    CALL     AX_BIT
                    CALL     PRINT_DX
                    CALL     PRINT_BP
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OCL_BIT_TYPE        ENDP

;*********************************************************

;******************
OCL_DIR_BP_IMM_TYPE PROC     NEAR
;******************
                    MOV      AX, CX
                    CALL     AX_DIR
                    CALL     PRINT_DX
                    MOV      AX, BP
                    CALL     HEX_BYTE
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OCL_DIR_BP_IMM_TYPE ENDP

;*********************************************************

;******************
OCL_DIR_BP_DIR_TYPE PROC     NEAR
;******************
                    MOV      AX, BP
                    CALL     AX_DIR
                    CALL     PRINT_DX
                    MOV      AX, CX
                    CALL     AX_DIR
                    CALL     DATA_COMMENT
                    AND      AL, FALSE
                    RET
;                   ********************

OCL_DIR_BP_DIR_TYPE ENDP

;*********************************************************

;*******
INO_DATA            PROC     NEAR
;*******
                    CLC
                    RET
;                   ********************

INO_DATA            ENDP

;*********************************************************

;***********
INO_DATA_UNC        PROC     NEAR
;***********
                    STC
                    RET
;                   ********************

INO_DATA_UNC        ENDP

;*********************************************************

;*********
IAJMP_TYPE          PROC     NEAR
;*********
                    CALL     SET_AJ_MAP
                    STC
                    RET
;                   ********************
IAJMP_TYPE          ENDP

;*********************************************************

;**********
IACALL_TYPE         PROC     NEAR
;**********
                    CALL     SET_AC_MAP
                    CLC
                    RET
;                   ********************

IACALL_TYPE         ENDP

;*********************************************************

;*********
ILJMP_TYPE          PROC     NEAR
;*********
                    CALL     SET_LJ_MAP
                    STC
                    RET
;                   ********************

ILJMP_TYPE          ENDP

;*********************************************************

;**********
ILCALL_TYPE         PROC     NEAR
;**********
                    CALL     SET_LC_MAP
                    CLC
                    RET
;                   ********************

ILCALL_TYPE         ENDP

;*********************************************************

;***********
IBP_REL_TYPE        PROC     NEAR
;***********
                    CALL     SET_RL_MAP
                    CLC
                    RET
;                   ********************

IBP_REL_TYPE        ENDP

;*********************************************************

;***************
IBP_REL_UNC_TYPE    PROC     NEAR
;***************
                    CALL      SET_RL_MAP
                    STC
                    RET
;                   ********************

IBP_REL_UNC_TYPE    ENDP

;*********************************************************

;******************
IDL_DIR_BP_REL_TYPE PROC     NEAR
;******************
                    PUSH     DX
                    CALL     SET_RL_MAP
                    POP      BP
                    CALL     SET_DR_MAP
                    CLC
                    RET
;                   ********************

IDL_DIR_BP_REL_TYPE ENDP

;*********************************************************

;******************
ICL_DIR_BP_REL_TYPE PROC     NEAR
;******************
                    PUSH     CX
                    CALL     SET_RL_MAP
                    POP      BP
                    CALL     SET_DR_MAP
                    CLC
                    RET
;                   ********************

ICL_DIR_BP_REL_TYPE ENDP

;*********************************************************

;******************
IDL_IMM_BP_REL_TYPE PROC     NEAR
;******************
                    CALL     SET_RL_MAP
                    CLC
                    RET
;                   ********************

IDL_IMM_BP_REL_TYPE ENDP

;*********************************************************

;******************
ICL_BIT_BP_REL_TYPE PROC     NEAR
;******************
                    PUSH     CX
                    CALL     SET_RL_MAP
                    POP      BP
                    CALL     SET_BT_MAP
                    CLC
                    RET
;                   ********************

ICL_BIT_BP_REL_TYPE ENDP

;*********************************************************

;****************
IBP_BYTE_IMM_TYPE   PROC     NEAR
;****************
                    CLC
                    RET
;                   ********************

IBP_BYTE_IMM_TYPE   ENDP

;*********************************************************

;****************
IBP_WORD_IMM_TYPE   PROC     NEAR
;****************
                    CLC
                    RET
;                   ********************

IBP_WORD_IMM_TYPE   ENDP

;*********************************************************

;***********
IBP_BIT_TYPE        PROC     NEAR
;***********
                    CALL     SET_BT_MAP
                    CLC
                    RET
;                   ********************

IBP_BIT_TYPE        ENDP

;*********************************************************

;***********
IBP_DIR_TYPE        PROC     NEAR
;***********
                    CALL     SET_DR_MAP
                    CLC
                    RET
;                   ********************

IBP_DIR_TYPE        ENDP

;*********************************************************

;***********
ICL_DIR_TYPE        PROC     NEAR 
;***********
                    MOV      BP, CX
                    CALL     SET_DR_MAP
                    CLC
                    RET
;                   ********************

ICL_DIR_TYPE        ENDP

;*********************************************************

;***********
ICL_BIT_TYPE        PROC     NEAR
;***********
                    MOV      BP, CX
                    CALL     SET_BT_MAP
                    CLC
                    RET
;                   ********************

ICL_BIT_TYPE        ENDP

;*********************************************************

;******************
ICL_DIR_BP_IMM_TYPE PROC     NEAR
;******************
                    MOV      BP, CX
                    CALL     SET_DR_MAP
                    CLC
                    RET
;                   ********************

ICL_DIR_BP_IMM_TYPE ENDP

;*********************************************************

                    PUBLIC   ICL_DIR_BP_DIR_TYPE
;******************
ICL_DIR_BP_DIR_TYPE PROC     NEAR
;******************
                    PUSH     CX
                    CALL     SET_DR_MAP
                    POP      BP
                    CALL     SET_DR_MAP
                    CLC
                    RET
;                   ********************

ICL_DIR_BP_DIR_TYPE ENDP

;*********************************************************

                    PUBLIC   DATA_COMMENT
;***********
DATA_COMMENT        PROC     NEAR
;***********
                    CALL     TO_COMMENT

                    MOV      AL, ';'
                    CALL     PRINT_AL
                    MOV      AL, ' '
                    CALL     PRINT_AL

                    MOV      AX, DI
                    SUB      AX, OFFSET OBJ_BUFFER
                    PUSH     AX
                    MOV      AL, AH
                    CALL     HX_BYTE
                    POP      AX
                    CALL     HX_BYTE

                    MOV      AL, ':'
                    CALL     PRINT_AL

                    XCHG     SI, DI

COMMENT_LOOP:       MOV      AL, ' '
                    CALL     PRINT_AL

                    LODSB
                    CALL     HX_BYTE

                    CMP      SI, DI
                    JNZ      COMMENT_LOOP

                    RET
;                   ********************

DATA_COMMENT        ENDP

;*********************************************************

                    PUBLIC   BP_USE
;*****
BP_USE              PROC     NEAR
;*****
                    PUSH     BX
                    CALL     PRINT_CX
                    CALL     PRINT_DX
                    POP      DX
                    CALL     PRINT_DX
                    MOV      AX, BP
                    JMP      HEX_WORD
;                   ********************

BP_USE              ENDP

;*********************************************************

                    PUBLIC   AX_DIR_GEN
;*********
AX_DIR_GEN          PROC     NEAR
;*********
                    PUSH     DX
                    PUSH     BX
                    PUSH     CX

                    MOV      CX, FALSE
                    JMP      AX_DIR_USE
;                   ********************

AX_DIR_GEN          ENDP

;*********************************************************

                    PUBLIC   AX_DIR
;*****
AX_DIR              PROC     NEAR
;*****
                    PUSH     DX
                    PUSH     BX
                    PUSH     CX

                    MOV      CX, TRUE
;**********
AX_DIR_USE:         CMP      AL, 080H
;**********
                    JB       AX_DIR_LOW

                    MOV      BX, AX
                    SHL      BL, 1
                    MOV      DX, [ DIR_TABLE.BX ]
                    OR       DX, DX
                    JZ       AX_DIR_NULL

                    CMP      CX, FALSE
                    JZ       AX_DIR_DNE2

                    CALL     PRINT_DX
                    JMP      AX_DIR_DNE
;                   ********************

AX_DIR_LOW:         CMP      AL, 020H
                    JNB      AX_DIR_NULL

                    MOV      BL, 8
                    DIV      BL
                    PUSH     AX
                    XOR      AH, AH
                    SHL      AX, 1
                    MOV      BX, AX
                    MOV      DX, [ RB_TABLE.BX ]
                    CALL     PRINT_DX

                    POP      AX
                    MOV      AL, AH
                    XOR      AH, AH
                    SHL      AX, 1
                    MOV      BX, AX
                    MOV      DX, [ REG_TABLE.BX ]
                    CALL     PRINT_DX
                    JMP      AX_DIR_DNE
;                   ********************

AX_DIR_NULL:        MOV      DX, OFFSET DR_LAB
                    CALL     PRINT_DX
                    CALL     HEX_BYTE

AX_DIR_DNE:         OR       AX, TRUE

AX_DIR_DNE2:        POP      CX
                    POP      BX
                    POP      DX
                    RET
;                   ********************

AX_DIR              ENDP

;*********************************************************

                    PUBLIC   AX_BIT
;*****
AX_BIT              PROC     NEAR
;*****
                    PUSH     BX
                    PUSH     CX
                    PUSH     DX
                    PUSH     SI
                    PUSH     BP

                    CMP      AL, 080H
                    JB       AX_BIT_LOW

                    AND      AL, 01111111B
                    MOV      CL, 8
                    DIV      CL
                   PUSH     AX
                    ROL      AL, 1                    
                    ROL      AL, 1                    
                    ROL      AL, 1                    
                    ADD      AL, 080H
                    JMP      AX_BIT_DNE
;                   ********************

AX_BIT_LOW:         MOV      CL, 8
                    DIV      CL
                   PUSH     AX
                    ADD      AL, 020H

AX_BIT_DNE:         XOR      AH, AH
                    MOV      SI, OFFSET PSW_TABLE
                    CMP      AL, 0D0H  ;PSW
                    JZ       SPECIAL_BIT

                    MOV      SI, OFFSET TCON_TABLE
                    CMP      AL, 088H
                    JZ       SPECIAL_BIT

                    MOV      SI, OFFSET IEC_TABLE
                    CMP      AL, 0A8H
                    JZ       SPECIAL_BIT

                    MOV      SI, OFFSET IPC_TABLE
                    CMP      AL, 0B8H
                    JZ       SPECIAL_BIT

                    MOV      SI, OFFSET SCON_TABLE
                    CMP      AL, 098H
                    JZ       SPECIAL_BIT

                    MOV      SI, OFFSET TMOD_TABLE
                    CMP      AL, 089H
                    JNZ      AX_BIT_NOT_SPECIAL

SPECIAL_BIT:       POP      AX
                   PUSH     AX
                    MOV      BL, AH
                    SHL      BL, 1
                    XOR      BH, BH
                    MOV      DX, CS:[ BX.SI ]
                    OR       DX, DX
                    JZ       AX_BIT_NOT_SPECIAL

                   POP      AX
                    CALL     PRINT_DX
                    JMP      AX_PSW_DNE
;                   ********************

AX_BIT_NOT_SPECIAL: CALL     AX_DIR

                    MOV      AL, '.'
                    CALL     PRINT_AL

                   POP      AX
                    MOV      AL, AH
                    OR       AL, '0'
                    CALL     PRINT_AL

AX_PSW_DNE:         POP      BP
                    POP      SI
                    POP      DX
                    POP      CX
                    POP      BX
                    RET
;                   ********************

AX_BIT              ENDP

;*********************************************************

                    PUBLIC   PRINT_AX
;*******
PRINT_AX            PROC     NEAR
;*******
                    XCHG     AX, DX
                    CALL     PRINT_DX
                    XCHG     AX, DX
                    RET
;                   ********************

PRINT_AX            ENDP

;*********************************************************

                    PUBLIC   PRINT_BP
;*******
PRINT_BP            PROC     NEAR
;*******
                    XCHG     BP, DX
                    CALL     PRINT_DX
                    XCHG     BP, DX
                    RET
;                   ********************

PRINT_BP            ENDP

;*********************************************************

                    PUBLIC   PRINT_CX
;*******
PRINT_CX            PROC     NEAR
;*******
                    XCHG     CX, DX
                    CALL     PRINT_DX
                    XCHG     CX, DX
                    RET
;                   ********************

PRINT_CX            ENDP

;*********************************************************

                    PUBLIC   TO_INSTRUCTION
;*************
TO_INSTRUCTION      PROC     NEAR
;*************
                    MOV      AX, INSTRUCTION_COLUMN
                    JMP      SPACE_TO_COLUMN
;                   ********************

TO_INSTRUCTION      ENDP

;*********************************************************

                    PUBLIC   TO_PARAMETERS
;************
TO_PARAMETERS       PROC     NEAR
;************
                    MOV      AX, PARAMETERS_COLUMN
                    JMP      SPACE_TO_COLUMN
;                   ********************

TO_PARAMETERS       ENDP

;*********************************************************

                    PUBLIC   TO_COMMENT
;*********
TO_COMMENT          PROC     NEAR
;*********
                    MOV      AX, COMMENT_COLUMN
                    JMP      SPACE_TO_COLUMN
;                   ********************

TO_COMMENT          ENDP

;*********************************************************

                    PUBLIC   SPACE_TO_COLUMN
;**************
SPACE_TO_COLUMN     PROC     NEAR
;**************
                    PUSH     BX
                    PUSH     CX
                    PUSH     DX
                    PUSH     BP

S2C_LOOP:           PUSH     AX
                    MOV      AL, ' '
                    CALL     PRINT_AL
                    POP      AX
                    CMP      AX, [ COLUMN ]
                    JG       S2C_LOOP

                    POP      BP
                    POP      DX
                    POP      CX
                    POP      BX

                    RET
;                   ********************

SPACE_TO_COLUMN     ENDP

;*********************************************************

                    PUBLIC   PRINT_DX
;*******
PRINT_DX            PROC     NEAR
;*******
                    PUSH     BP
                    PUSH     CX
                    PUSH     AX
                    PUSH     DX
                    PUSH     BX

                    MOV      BX, DX

PDX_LOOP:           MOV      AL, CS:[ BX ]
                    INC      BX
                    OR       AL, AL
                    JZ       PDX_DNE

                    CALL     PRINT_AL
                    JMP      PDX_LOOP
;                   ********************

PDX_DNE:            POP      BX
                    POP      DX
                    POP      AX
                    POP      CX
                    POP      BP
                    RET
;                   ********************

PRINT_DX            ENDP

;*********************************************************

                    PUBLIC   PRINT_AL
;*******
PRINT_AL            PROC     NEAR
;*******
                    CMP      AL, CR
                    JNZ      PAL_NOT_CR

                    CMP      [ COLUMN ], 0
                    MOV      [ COLUMN ], 0
                    JNZ      PAL_OK

                    MOV      [ BLANK_LINE_FLAG ], -1

PAL_NOT_CR:         CMP      AL, ' '
                    JB       PAL_OK

                    INC      [ COLUMN ]
                    MOV      [ BLANK_LINE_FLAG ], 0

PAL_OK:             MOV      DL, AL
                    MOV      AH, PRINT_CHARACTER
                    INT      DOS_FUNCTION
                    RET
;                   ********************

PRINT_AL            ENDP

;*********************************************************

                    PUBLIC   HEX_WORD
;*******
HEX_WORD            PROC     NEAR
;*******
                    PUSH     CX
                    PUSH     DX
                    PUSH     BP

                   PUSH     AX
                    MOV      AL, '0'
                    CALL     PRINT_AL
                   POP      AX
                   PUSH     AX
                    MOV      AL, AH
                    CALL     HX_BYTE
                   POP      AX
                    CALL     HX_BYTE
                    MOV      AL, 'H'
                    CALL     PRINT_AL

                    POP      BP
                    POP      DX
                    POP      CX
                    RET
;                   ********************

HEX_WORD            ENDP

;*********************************************************

                    PUBLIC   HEX_BYTE
;*******
HEX_BYTE            PROC     NEAR
;*******
                    PUSH     CX
                    PUSH     DX
                    PUSH     BP

                   PUSH     AX
                    MOV      AL, '0'
                    CALL     PRINT_AL
                   POP      AX
                    CALL     HX_BYTE
                    MOV      AL, 'H'
                    CALL     PRINT_AL

                    POP      BP
                    POP      DX
                    POP      CX
                    RET
;                   ********************

HEX_BYTE            ENDP

;*********************************************************

                    PUBLIC   HX_BYTE, HX_NYBL
;******
HX_BYTE             PROC     NEAR
;******
                    PUSH     AX

                    ROR      AX, 1
                    ROR      AX, 1
                    ROR      AX, 1
                    ROR      AX, 1
                    CALL     HX_NYBL

                    POP      AX
;******
HX_NYBL             PROC     NEAR
;******
                    AND      AL, 00001111B
                    ADD      AL, 090H
                    DAA
                    ADC      AL, 040H
                    DAA
                    JMP      PRINT_AL
;                   ********************

HX_NYBL             ENDP
HX_BYTE             ENDP

;*********************************************************

                    PUBLIC   DIS_VECTOR
;*********
DIS_VECTOR          PROC     NEAR
;*********
                    LODSB
                    XOR      AH, AH
                    ADD      AX, AX
                    MOV      BX, AX
                    JMP      [DIS_TABLE.BX]
;                   ********************

DIS_VECTOR          ENDP

;*********************************************************

                    PUBLIC   GET_BYTE
;*******
GET_BYTE            PROC     NEAR
;*******
                    PUSH     BX
                    PUSH     CX
                    PUSH     DX

                    CALL     NYBLE
                    MOV      CL, 3*4        ;three nybles
                    SHL      AX, CL         ;put AL:0-3 in AH:4-7
                    PUSH     AX
                    CALL     NYBLE
                    POP      BX
                    AND      AL, 00001111B
                    OR       AL, BH
                    XOR      AH, AH

                    POP      DX
                    POP      CX
                    POP      BX
                    RET
;                   ******************************

GET_BYTE            ENDP

;********************************************************************

                    PUBLIC   NYBLE
;****
NYBLE               PROC     NEAR
;****
                    CALL     KEY
                    AND      AL, 01111111B
                    CMP      AL, '0'
                    JB       NYBLE_BAD

                    CMP      AL, ( 'F' +1 )
                    JNB      NYBLE_BAD

                    CMP      AL, '9'
                    JBE      NYBLE_OK

                    CMP      AL, 'A'
                    JB       NYBLE_BAD

                    SUB      AL, ( 'A' - ( '9'+1 ) )

NYBLE_OK:           AND      AL, 00001111B
                    RET
;                   ******************************

NYBLE_BAD:          MOV      DX, OFFSET NOT_HEX
                    JMP      FATAL_ERROR
;                   ********************

NYBLE               ENDP

;*********************************************************

                    PUBLIC   KEY
;**
KEY                 PROC     NEAR
;**
                    CALL     GET_KEY
                    JZ       END_KEY

                    RET
;                   ********************

END_KEY:            MOV      DX, OFFSET PREMATURE_EOF
                    JMP      FATAL_ERROR
;                   ********************

KEY                 ENDP

;********************************************************************

                    PUBLIC   GET_KEY
;******
GET_KEY             PROC     NEAR
;******
                    MOV      AH, GET_CHARACTER
                    INT      DOS_FUNCTION
                    CMP      AL, EOF
                    RET
;                   ********************

GET_KEY             ENDP

;*********************************************************

                    PUBLIC   SET_AJ_MAP
;*********
SET_AJ_MAP          PROC     NEAR
;*********
                    CALL     ADDRESS_BIT
                    TEST     [ AJ_MAP.BP ], AL
                    JNZ      SAJ_DNE

                    OR       [ AJ_MAP.BP ], AL
                    OR       [ MAPS_CHANGED_FLAG ], TRUE

SAJ_DNE:            RET
;                   ********************

SET_AJ_MAP          ENDP

;*********************************************************

                    PUBLIC   SET_LJ_MAP
;*********
SET_LJ_MAP          PROC     NEAR
;*********
                    CALL     ADDRESS_BIT
                    TEST     [ LJ_MAP.BP ], AL
                    JNZ      SLJ_DNE

                    OR       [ LJ_MAP.BP ], AL
                    OR       [ MAPS_CHANGED_FLAG ], TRUE

SLJ_DNE:            RET
;                   ********************

SET_LJ_MAP          ENDP

;*********************************************************

                    PUBLIC   SET_AC_MAP
;*********
SET_AC_MAP          PROC     NEAR
;*********
                    CALL     ADDRESS_BIT
                    TEST     [ AC_MAP.BP ], AL
                    JNZ      SAC_DNE

                    OR       [ AC_MAP.BP ], AL
                    OR       [ MAPS_CHANGED_FLAG ], TRUE

SAC_DNE:            RET
;                   ********************

SET_AC_MAP          ENDP

;*********************************************************

                    PUBLIC   SET_LC_MAP
;*********
SET_LC_MAP          PROC     NEAR
;*********
                    CALL     ADDRESS_BIT
                    TEST     [ LC_MAP.BP ], AL
                    JNZ      SLC_DNE

                    OR       [ LC_MAP.BP ], AL
                    OR       [ MAPS_CHANGED_FLAG ], TRUE

SLC_DNE:            RET
;                   ********************

SET_LC_MAP          ENDP

;*********************************************************

                    PUBLIC   SET_RL_MAP
;*********
SET_RL_MAP          PROC     NEAR
;*********
                    CALL     ADDRESS_BIT
                    TEST     [ RL_MAP.BP ], AL
                    JNZ      SRL_DNE

                    OR       [ RL_MAP.BP ], AL
                    OR       [ MAPS_CHANGED_FLAG ], TRUE

SRL_DNE:            RET
;                   ********************

SET_RL_MAP          ENDP

;*********************************************************

                    PUBLIC   SET_BT_MAP
;*********
SET_BT_MAP          PROC     NEAR
;*********
                    MOV      AX, BP
                    CMP      AL, 080H
                    JB       SET_BT_LOW

                    AND      AL, 01111111B
                    MOV      CL, 8
                    DIV      CL
                    ROL      AL, 1                    
                    ROL      AL, 1                    
                    ROL      AL, 1                    
                    ADD      AL, 080H
                    JMP      SET_BT_DNE
;                   ********************

SET_BT_LOW:         MOV      CL, 8
                    DIV      CL
                    ADD      AL, 020H

SET_BT_DNE:         XOR      AH, AH
                    MOV      BP, AX
                    JMP      SET_DR_MAP
;                   ********************

SET_BT_MAP          ENDP

;*********************************************************

                    PUBLIC   SET_DR_MAP
;*********
SET_DR_MAP          PROC     NEAR
;*********
                    CALL     ADDRESS_BIT
                    TEST     [ DR_MAP.BP ], AL
                    JNZ      SDR_DNE

                    OR       [ DR_MAP.BP ], AL
                    OR       [ MAPS_CHANGED_FLAG ], TRUE

SDR_DNE:            RET
;                   ********************

SET_DR_MAP          ENDP

;*********************************************************

                    PUBLIC   TEST_AJ_MAP
;**********
TEST_AJ_MAP         PROC     NEAR
;**********
                    CALL     ADDRESS_BIT
                    TEST     [ AJ_MAP.BP ], AL
                    RET
;                   ********************

TEST_AJ_MAP         ENDP

;*********************************************************

                    PUBLIC   SET_OR_MAP
;*********
SET_OR_MAP          PROC     NEAR
;*********
                    CALL     ADDRESS_BIT
                    TEST     [ OR_MAP.BP ], AL
                    JNZ      SOR_DNE

                    OR       [ OR_MAP.BP ], AL
                    OR       [ MAPS_CHANGED_FLAG ], TRUE

SOR_DNE:            RET
;                   ********************

SET_OR_MAP          ENDP

;*********************************************************

                    PUBLIC   TEST_OR_MAP
;**********
TEST_OR_MAP         PROC     NEAR
;**********
                    CALL     ADDRESS_BIT
                    TEST     [ OR_MAP.BP ], AL
                    RET
;                   ********************

TEST_OR_MAP         ENDP

;*********************************************************

                    PUBLIC   TEST_LJ_MAP
;**********
TEST_LJ_MAP         PROC     NEAR
;**********
                    CALL     ADDRESS_BIT
                    TEST     [ LJ_MAP.BP ], AL
                    RET
;                   ********************

TEST_LJ_MAP         ENDP

;*********************************************************

                    PUBLIC   TEST_AC_MAP
;**********
TEST_AC_MAP         PROC     NEAR
;**********
                    CALL     ADDRESS_BIT
                    TEST     [ AC_MAP.BP ], AL
                    RET
;                   ********************

TEST_AC_MAP         ENDP

;*********************************************************

                    PUBLIC   TEST_LC_MAP
;**********
TEST_LC_MAP         PROC     NEAR
;**********
                    CALL     ADDRESS_BIT
                    TEST     [ LC_MAP.BP ], AL
                    RET
;                   ********************

TEST_LC_MAP         ENDP

;*********************************************************

                    PUBLIC   TEST_RL_MAP
;**********
TEST_RL_MAP         PROC     NEAR
;**********
                    CALL     ADDRESS_BIT
                    TEST     [ RL_MAP.BP ], AL
                    RET
;                   ********************

TEST_RL_MAP         ENDP

;*********************************************************

                    PUBLIC   TEST_DR_MAP
;**********
TEST_DR_MAP         PROC     NEAR
;**********
                    CALL     ADDRESS_BIT
                    TEST     [ DR_MAP.BP ], AL
                    RET
;                   ********************

TEST_DR_MAP         ENDP

;*********************************************************

                    PUBLIC   ADDRESS_BIT
;**********
ADDRESS_BIT         PROC     NEAR
;**********
                    PUSH     BX
                    PUSH     CX
                    PUSH     DX

                    MOV      AX, BP
                    MOV      BX, 8
                    XOR      DX, DX
                    DIV      BX
                    MOV      BP, AX
                    MOV      CX, DX
                    INC      CX
                    MOV      AL, 080H

AB_LOOP:            ROL      AL, 1
                    LOOP     AB_LOOP

                    POP      DX
                    POP      CX
                    POP      BX
                    RET
;                   ********************

ADDRESS_BIT         ENDP

;*********************************************************

CSEG                ENDS

;                   ********************

                    END      UN51

